#ifndef OPTION_BASE_H_
#define OPTION_BASE_H_

/**
	ϴ쥯饹
	$Id: option_base.h,v 1.1.1.1 2004/12/08 14:32:34 herumi Exp $
	Ŭ
	@note Ȥ

	bool analyze(int argc, const char *const argv[])
	{
		set(argc, argv);

		while (hasOption()) {
			if (isMatch("-width", 1)) {
				width_ = getInteger();
			} else
			if (isMatch("-tcp", 0)) {
				isTCP_ = true;
			} else
			{
				usage();
				return false;
			}
			next();
		}
		...
	}
*/
class OptionBase {
private:
	int argc_;
	const char *const* argv_;

protected:
	virtual void usage() = 0;

	inline void next()
	{
		argc_--, argv_++;
	}
	inline bool hasOption() const
	{
		return argc_ > 0;
	}
	/**
		ץ˥ޥå
		@param option [in] Ĵ٤ץ(:"-width")
		@param optNum [in] ץ󤬤Ȥο
		@note optNum > 0 ΤȤϳƼnext()(optNum - 1)Ƥ֤
	*/
	inline bool isMatch(const char *option, int optNum = 0)
	{
		if (argc_ > optNum && strcmp(*argv_, option) == 0) {
			if (optNum > 0) {
				next();
			}
			return true;
		}
		return false;
	}
	inline const char *getString() const { return *argv_; }
	inline int getInteger() const { return atoi(*argv_); }

	void set(int argc, const char *const* argv)
	{
		argc_ = argc;
		argv_ = argv;
		next();
	}

public:
	OptionBase()
		: argc_(0)
		, argv_(0)
	{
	}
	virtual ~OptionBase()
	{
	}
	virtual bool analyze(int argc, const char *const argv[]) = 0;
};

#endif /* OPTION_BASE_H_ */
