/*
 * TestFailure.h
 */

#ifndef cppunit_TestFailure_h
#define cppunit_TestFailure_h

#include "cuconfig.h"

cu_NAMESPACE_BEGIN(cppunit)

class Test;

/**
 * ԤƥȤξ<br>
 * Record of a failed test execution.
 *
 * A TestFailure collects a failed test.
 *
 * @see TestResult
 */
class TestFailure
{
  public:
	/**
	 * 󥹥ȥ饯
	 * @param test Ԥƥȡ
	 * @param msg  å
	 * @param file ꤬ȯե̾
	 * @param line ꤬ȯֹ档
	 */
	TestFailure(Test* test, const cu_String& msg, const char* file, long line);

	/** ǥȥ饯 */
	~TestFailure() {}

	/** ԤƥȤ֤ */
	Test* failedTest() const { return m_failedTest; }

	/** ԤƥȤξ֤ */
	const char* what() const { return m_message.c_str(); }

	/** ꤬ȯե֤̾ */
	const char* file() const { return m_file; }

	/** ꤬ȯֹ֤ */
	long line() const { return m_line; }

	/** ʸѴ롣 */
	cu_String toString() const;

  private:
	Test* m_failedTest;
	cu_String   m_message;
	const char* m_file;
	long        m_line;
};

cu_NAMESPACE_END

#endif /* !cppunit_TestFailure_h */
