/*
 * TestRegistry.h
 */

#ifndef cppunit_TestRegistry_h
#define cppunit_TestRegistry_h

#include "cuconfig.h"
#include "Test.h"

cu_NAMESPACE_BEGIN(cppunit)

class TestResult;

/**
 * ƥȤϿ륯饹
 *
 * TestRunner μǻѡ
 * CppUnit 1.6.x  TestRegistry ȤӤ¿ۤʤ롣
 * 
 * ͭ Test Υ饤ե롣
 */
class TestRegistry
{
  public:
	/** 󥹥ȥ饯 */
	TestRegistry() {}

	/** ǥȥ饯 */
	~TestRegistry();

	/**
	 * ƥȤɲä롣
	 * @param name ƥ̾
	 * @param test ɲäƥȡ
	 */
	void addTest(const char* name, Test* test);

	/**
	 * ꤵ줿̾ΥƥȤͭˤ롣
	 * @param name ƥ̾
	 * @return ƥȤ뤫?
	 */
	bool setAvailable(const char* name, bool value = true);

	/** ƤΥƥȤͭˤ롣 */
	void setAllAvailable(bool value = true);

	/** ͭʥƥȤ뤫? */
	bool hasAvailables() const;

	/** ɲä줿ƥȤΥꥹȤ֤ */
	const cu_List& entries() const { return m_entries; }

	/**
	 * ƥȤ¹Ԥ롣
	 * @param result ƥȷ̡
	 */
	void runTests(TestResult* result);

  private:
	int m_availables;
	cu_List m_entries;	// list<Entry*>

  public:
	/**
	 * ƥȤΥȥꡣ
	 */
	class Entry {
	  public:
		/**
		 * 󥹥ȥ饯
		 * @param name      ƥ̾
		 * @param test      ƥȡ
		 * @param available ƥȤͭ?
		 */
		Entry(const char* name, Test* test, bool available = false)
			: m_name(name), m_test(test), m_available(available) {}

		/** ǥȥ饯 */
		~Entry() { delete m_test; }

		/** ƥ֤̾ */
		const char* getName() const { return m_name.c_str(); }

		/** ƥȤ֤ */
		Test* getTest() const { return m_test; }

		/** ƥȤͭ? */
		bool isAvailable() const { return m_available; }

		/**
		 * ƥȤͭꤹ롣
		 * @param value ꤹ͡
		 */
		void setAvailable(bool value = true) { m_available = value; }

	  private:
		cu_String m_name;
		Test* m_test;
		bool  m_available;
	};
};

cu_NAMESPACE_END

#endif /* !cppunit_TestRegistry_h */
