#ifndef F2POLY_H_
#define F2POLY_H_
/**
	@file f2poly.h
	@brief F2¿༰饹ե
	@author $Author: herumi $
	@version $Revision: 1.40 $
	@date $Date: 2005/02/17 14:59:35 $
*/

/*
	
*/
#ifdef USE_BOOST
	#include <boost/pool/pool_alloc.hpp>
	#define OPTIONAL_ALLOC , boost::pool_allocator<F2term> /**/
#elif defined(USE_MYALLOC)
	#include "myalloc.h"
	#define OPTIONAL_ALLOC , myalloc<F2term> /**/
#else
	#define OPTIONAL_ALLOC
#endif

#include "f2term.h"
//#if defined(WIN32) //#ifdef __ICL
//	#include "f2termx4.h"
//#endif
#include <vector>
#include <functional>
#include <algorithm>
#include <cassert>
#include <list>
#include <set>
#include <iomanip>

/*
	ƥʤ
*/
#if defined(USE_SET) && !defined(USE_MYSET)
	#define  POLY_CONT std::set
	#define  OPTIONAL_COMP ,std::greater<F2term>
#elif defined(USE_MYLIST)
	#include "mylist.h"
	#define  POLY_CONT mylist
	#define  OPTIONAL_COMP
#elif defined(USE_MYSET)
	#include "myset.h"
	#define  POLY_CONT myset
	#define  OPTIONAL_COMP ,std::greater<F2term>
#else
	#define  POLY_CONT std::list
	#define  OPTIONAL_COMP
#endif

#ifdef USE_MUL_F2TERM_SSE2
extern "C" void mul_f2termx4_SSE2(void* pitr, const F2term* rhs, size_t n);
#endif

namespace Hotaru {

/**
	F2¿༰饹
	@note
	Nѿ¿༰ R = F2[x_1, ..., x_N]
	ǰ¿༰
	f(X) =  X^ ηɽ롥
	 X^ =  x_i{1, ..., N}ʬ
	             i

	F2ʤΤLCϾ1ʤΤLT=LM
*/
class F2poly : private POLY_CONT <F2term OPTIONAL_COMP OPTIONAL_ALLOC>
//class F2poly : public POLY_CONT <F2term OPTIONAL_COMP OPTIONAL_ALLOC>
{
	friend std::ostream& operator<<(std::ostream& os, const F2poly& f);
	friend std::istream& operator>>(std::istream& is, F2poly& x);

	typedef F2poly::const_iterator const_iterator;
public:
	typedef F2poly::iterator iterator;
private:
#if USE_SET
	typedef std::pair<iterator, bool> Pair;
#endif

	/* list->vectΥإѡؿ */
//	static inline F2poly* ref_to(F2poly& x) { return &x; }
	static inline F2poly* ref_to(const F2poly& x) { return const_cast<F2poly*>(&x); }

public:
	/*
		¿༰νñΤǤγ껻ϥ٥ȥ뤬˾ޤ
		֥ʡǤϿ¿ΤǥꥹȤˤ롥
	*/
	typedef std::list<F2poly> Set;
	typedef std::vector<F2poly*> pvecSet; /* Ǥ٥ȥǰȤ */

	F2poly()
	{
	}

	/**
		ʸˤ
		ʸʤȤ
	*/
	explicit F2poly(const char* str)
	{
		std::istringstream istr(str);
		istr >> *this;
	}

	/**
		ñ༰¿༰
	*/
	explicit F2poly(const F2term& x)
	{
#ifdef USE_SET
		clear();
		insert(x);
#else
		*this = x;
#endif
	}

	/**
	  ԥ٥ȥ뤫
	  fȤԥ٥ȥɽ
	  @note: *pˤ*thisιХʬηäƤ뤳
	*/
	F2poly(F2poly const& f, char const *p) {
		clear();
		for(const_iterator i = f.begin(); i != f.end(); ++i) {
			if(*p++) insert(end(), *i);
		}
	}
	
	/**
		μ
	*/
	inline size_t getNumOfTerm() const
	{
		return size();
	}

	/**
		0ݤ
	*/
	inline bool isZero() const
	{
		return getNumOfTerm() == 0;
	}

	/**
		ǹ⼡ι (copyʤ)
	*/
	inline F2term const& LT() const
	{
		assert(!isZero());
		return *begin();
	}

	/**
		ǹ⼡ñ༰(copyʤ)
	*/
	inline F2term const& LM() const { return LT(); }

	/**
		ǹ⼡μ
		@note 0ΤȤ-1֤
	*/
	inline int getMltDeg() const {
		assert(!isZero());
		return LT().getDegree();
	}

	/**
		ñ༰
	*/
	inline F2poly operator=(const F2term& rhs)
	{
		clear();
#ifdef USE_SET
		insert(rhs);
#else
		push_back(rhs);
#endif
		MAX_ASSERT(isValid());
		return *this;
	}

	/**
		(ι⤤󤷡Ʊʪк)
	*/
	inline void normalize()
	{
#ifndef USE_SET
		sort(std::greater<F2term>()); /* ι⤤ */

		/* Ʊʪк */
		iterator itr = begin();
		while (itr != end()) {
			iterator next = itr;
			++next;
			if (next != end() && *itr == *next) {
				/* 2 */
				itr = erase(itr);
				itr = erase(itr);
			} else {
				itr = next;
			}
		}
#endif
	}

	/**
		ñ༰­
		礭¤٤­Ƥ
		ƱबФ⤦­0ʤΤǤιϺ
		@param rhs [in] ­ñ༰
	*/
	F2poly& operator+=(const F2term& rhs)
	{
#ifdef USE_SET
		Pair pair = insert(rhs);
		if (!pair.second) {
			/* ¸ߤƤк */
			erase(pair.first);
		}
#else
		for (iterator itr = begin(); itr != end(); ++itr) {
			if (rhs > *itr) {
				insert(itr, rhs);
				MAX_ASSERT(isValid());
				return *this;
			} else if (rhs == *itr) {
				erase(itr); // rhs + rhs = 0 mod 2
				MAX_ASSERT(isValid());
				return *this;
			}
		}
		push_back(rhs); /* ־äΤǺǸ˲ä */

		MAX_ASSERT(isValid());
#endif
		return *this;
	}

	/**
		¿༰­
		礭¤٤­Ƥ
		ƱबФ⤦­0ʤΤǤιϺ
		@param rhs [in] ­¿༰
	*/
	F2poly& operator+=(const F2poly& rhs)
	{
		if (this == &rhs) {
			clear();
		} else
		if (!rhs.isZero()) {

#if 0	/* QQQ: Ӳ򸺤餹ȤǤϤ */
			for (const_iterator itr = rhs.begin(); itr != rhs.end(); ++itr) {
				*this += *itr;
			}
#else
			iterator i1 = begin();
			const_iterator i2 = rhs.begin();
			while(i1 != end() && i2 != rhs.end()) {
				if(*i1 > *i2) ++i1;
				else if(*i1 < *i2) {
					i1 = insert(i1, *i2++);
					++i1;
				} else {
					erase(i1++);
					++i2;
				}
			}
#ifdef USE_SET
			for(; i2 != rhs.end(); ++i2) insert(end(), *i2);
#else
			insert(end(), i2, rhs.end());
#endif
#endif
		}
		MAX_ASSERT(isValid());
		return *this;
	}

	/**
		(­alias)
	*/
	F2poly& operator-=(const F2term& rhs) { return operator+=(rhs); }
	F2poly& operator-=(const F2poly& rhs) { return operator+=(rhs); }

#if 0
	static void* incIter(F2poly::iterator *itr)
	{
		void *p = (void*)&**itr;
		++(*itr);
		return p;
	}
	/*
		@param pitr [inout] ƥ졼ݥ
		@param c [in] ݤ
		@param n [in] 
	*/
	static void mul_f2termx4(iterator* pitr, const F2term* rhs, size_t n)
	{
		do {
			void *p;
			p = incIter(pitr);
			*(F2term*)p *= *rhs;
			p = incIter(pitr);
			*(F2term*)p *= *rhs;
			p = incIter(pitr);
			*(F2term*)p *= *rhs;
			p = incIter(pitr);
			*(F2term*)p *= *rhs;
			n -= 4;
		} while (n >= 4);
	}
#endif

	/**
		ñ༰γݤ
		@note ݤǽݤ
		@note QQQ:!!!
		"(2, 4) + (1, 3)" * "(1, 4)" = "(1, 2, 4) + (1, 3, 4)"󤵤Ƥʤ
		"(1) + (2)" * "(1, 2)" = 0
	*/
	F2poly& operator*=(const F2term& rhs)
	{
#ifdef USE_SET
		F2poly ret;
		for (iterator itr = begin(); itr != end(); ++itr) {
			F2term t = *itr;
			t *= rhs;
			ret += t;
		}
		swap(ret);
#else
//clkbegin();
#ifdef USE_MUL_F2TERM_SSE2
		int n = size();
		iterator itr = begin();
		if (n >= 4) {
//			mul_f2termx4(&itr, &rhs, n);
			mul_f2termx4_SSE2(&itr, &rhs, n);
		}
		while (itr != end()) {
			*itr *= rhs;
			++itr;
		}
#else
		/* 35003700clk@D12 */
		for (iterator itr = begin(); itr != end(); ++itr) {
			*itr *= rhs;
		}
#endif
//clkend();
		/* 4000clk */
		normalize(); /* ɬ */
		MAX_ASSERT(isValid());
#endif
		return *this;
	}

	/*
		xi
	*/
	F2poly& multiplyByX(size_t i)
	{
#ifdef USE_SET
		F2poly ret;
		for (iterator itr = begin(); itr != end(); ++itr) {
			F2term t = *itr;
			t.setVar(i);
			ret += t;
		}
		swap(ret);
#else
		for (iterator itr = begin(); itr != end(); ++itr) {
			itr->setVar(i);
		}
		normalize(); /* ɬ */
		MAX_ASSERT(isValid());
#endif
		return *this;
	}

	/**
		¿༰γݤ
		QQQ: ̵̤򸺤餹٤
	*/
	F2poly& operator*=(const F2poly& rhs)
	{
		if (rhs.isZero()) {
			clear();
		} else {
			F2poly sum;
			for (const_iterator itr = rhs.begin(); itr != rhs.end(); ++itr) {
				F2poly line;
				line = *this;
				line *= *itr;
				sum += line;
			}
			*this = sum;
		}
		MAX_ASSERT(isValid());
		return *this;
	}

	/**
		fgȤSñ༰
		@note f == 0 or g == 0ΤȤ
	*/
	static inline F2poly GetSpoly(const F2poly& f, const F2poly& g)
	{
		assert(!f.isZero() && !g.isZero());
//std::cout << "Sij(" << f << ", " << g << ")\n";

		F2poly ret;

		if (&f != &g) {
			const F2term& cf = f.LT();
			const F2term& cg = g.LT();
#ifdef USE_MYLISTxxxxSlower
			F2term t1 = F2term::getLCM(cf, cg);
			F2term t2(t1); t1/=cf; t2/=cg;
			typedef std::set<F2term, std::greater<F2term> > Terms;
			typedef std::pair<Terms::iterator, bool> TPair;
			Terms tf;
			const_iterator i;
			for(i = f.begin(), ++i; i != f.end(); ++i) {
				TPair p = tf.insert(*i*t1);
				if(!p.second) tf.erase(p.first);
			}
			for(i = g.begin(), ++i; i != g.end(); ++i) {
				TPair p = tf.insert(*i*t2);
				if(!p.second) tf.erase(p.first);
			}
			for(Terms::iterator iT = tf.begin(); iT != tf.end();
				++iT) ret.insert(ret.end(), *iT);
#else
			F2term lcm = F2term::getLCM(cf, cg);
			ret = f;
			F2poly tmp = g;
			ret *= (lcm / cf);
			tmp *= (lcm / cg);
			ret -= tmp;
#endif
		}
		return ret;
	}

	/**
		fx_i^2 - x_iȤSñ༰
		@note f == 0 ΤȤ
		äȥޡȤˤǤ äȸΨ
	*/
	static inline F2poly GetSpoly(const F2poly& f, size_t i)
	{
//std::cout << "Si(" << f << ", " << i << ")\n";
		assert(!f.isZero() && i < MAX_NUM_OF_VARIABLE);
		F2poly s = f;
		s.multiplyByX(i);
		s -= f; // s = xi f - f
		return s;
	}

	/**
		F٥ȥ
		QQQ : FθθĿѹȤǤϻȤʤ
		@param F [in] ¿༰
	*/
	static inline pvecSet convertToVector(const Set& F)
	{
		pvecSet v(F.size());
		std::transform(F.begin(), F.end(), v.begin(), F2poly::ref_to);
		return v;
	}

	/**
		rhsǳä;r롥
		LM(rhs) | LM(this) ǤʤФʤʤ

		¿༰f(this), g(rhs)ˤĤ
		f = LMf + f~, g = LMg + g~, LMf = LMg Q, Q:ñ༰ΤȤ
		r = f - gQ = f~ - g~ Q롥
		ΤȤ deg(r) < deg(LMf)
		ͤϾQ
	*/
	inline F2term dividedAndGetQuotientBy(const F2poly& rhs)
	{
		F2poly q = rhs;
		assert(LM().canBeDividedBy(rhs.LM()));
		F2term c = LM() / rhs.LM();
		q *= c;
		*this -= q;
		return c;
	}

	/**
		rhsǳä;r롥
		LM(rhs) | LM(this) ǤʤФʤʤ
		@note dividedAndGetQuotientBy()ξƤ
	*/
	inline void dividedBy(const F2poly& rhs)
	{
		F2poly q = rhs;
		assert(LM().canBeDividedBy(rhs.LM()));
		F2term c = LM() / rhs.LM();
		q *= c;
		*this -= q;
	}

	/**
		LM(rhs)ʤʤޤǳڤ
		f = this, g = rhs
		1. fΤLMgǳΤ򽸤᤿¿༰FȤ롥
		2. F != 0ʤf  f - (F/LMg)gȤ1롥
		3. F == 0ʤ齪λ
		@retval true ѹä
		@retval false ѹʤ
	*/
	inline bool reducedBy(const F2poly& rhs)
	{
		assert(!rhs.isZero());
		const F2term& LMg = rhs.LM();
		bool isChanged = false;

		for (;;) {
			F2poly F;
			/* F/LMg׻ */
			for (iterator itr = begin(); itr != end(); ++itr) {
				if (itr->canBeDividedBy(LMg)) {
					F += (*itr / LMg);
				}
			}
			if (F.isZero()) {
				return isChanged;
			}
			F *= rhs;
			*this -= F;
			isChanged = true;
		}
		return false; /* don't here */
	}
	inline bool reducedNoHeadBy(const F2poly& rhs)
	{
		if(size() < 2) return false;
		F2term lm = LM();
		operator-=(lm);
		bool ret = reducedBy(rhs);
		operator+=(lm);
		return ret;
	}

	/**
		F = {f1, ..., fm}ˤfγ껻Ԥf;rˤʤ롥
		ͤϾ{g1, ..., gm}
		f = *thisȤ
		f = ( g_i f_i) + r
		degree(g_i f_i) <= degree(f)

		@param F [in] ¿༰ν
		@note uniqǤϤʤ
	*/
	Set dividedAndGetQuotientBy(const Set& F)
	{
		F2poly& f = *this;
		F2poly r;
		const pvecSet vF = convertToVector(F);
		const int m = vF.size();
		assert(m > 0);
#ifndef NDEBUG
		const int degf = f.getMltDeg();
#endif

		Set G(m); /* mĤ0θǽ */
		pvecSet vG = convertToVector(G);

		while (!f.isZero()) {
			F2term LMf = f.LM(); // need copy
			bool found = false;

			for (int j = 0; j < m; j++) {
				if (LMf.canBeDividedBy(vF[j]->LM())) {
					/*
						find j s.t. LM(fj) | LM(f)
						f <- f - LT(f)/LT(fj) fj
						gj <- gj + LT(f)/LT(fj)
					*/
					F2term c = f.dividedAndGetQuotientBy(*vF[j]);
					*vG[j] += c;
					found = true;
					break;
				}
			}
			if (!found) {
				F2term LTf = f.LT(); // need copy
				f -= LTf;
				r += LTf;
			}
		}

#ifndef NDEBUG
		/* å */
		for (int i = 0; i < m; i++) {
			F2poly t = *vG[i];
			if (!t.isZero()) {
				t *= *vF[i];
//				std::cout << "t.getMltDeg()=" << t.getMltDeg() << ", degf=" << degf << std::endl;
				assert(t.getMltDeg() <= degf);
			}
		}
#endif
		f = r;
		return G;
	}

	/**
		F = {f1, ..., fm}ˤfγ껻Ԥf;rˤʤ롥
		ͤϤʤ
		f = *thisȤ
		f = ( g_i f_i) + r
		degree(g_i f_i) <= degree(f)

		@param F [in] ¿༰ν
		@note uniqǤϤʤ
		QQQ : ɬפʤȤϤȤ
	*/
	void dividedBy(const Set& F)
	{
		F2poly& f = *this;
		F2poly r;

		const pvecSet vF = convertToVector(F);
		const int m = vF.size();
		assert(m > 0);

		while (!f.isZero()) {
			F2term LMf = f.LM(); // need copy
			bool found = false;

			for (int j = 0; j < m; j++) {
				if (LMf.canBeDividedBy(vF[j]->LM())) {
					/*
						find j s.t. LM(fj) | LM(f)
						f <- f - LT(f)/LT(fj) fj
					*/
					f.dividedBy(*vF[j]);
					found = true;
					break;
				}
			}
			if (!found) {
				F2term LTf = f.LT(); // need copy
				f -= LTf;
				r += LTf;
			}
		}

		f = r;
	}

	/**
		
		줾¿༰礭Τ¤٤Τ⼡ν
		Ӥ

		@param rhs [in] 
		@param considerNumTerm [in] ξʤΤͥ褹
		@retval  1 if this >  rhs
		@retval  0 if this == rhs
		@retval -1 if this <  rhs
	*/
	inline int isGreater(const F2poly& rhs, bool considerNumTerm = false) const
	{
		size_t numTermL = this->size();
		size_t numTermR = rhs.size();
		size_t n = (numTermL < numTermR) ? numTermL : numTermR; /* ξ */
		/* ξ0 */
		if (n == 0) return 0;
		/* this == 0 */
		if (numTermL == 0) return -1;
		/* rhs == 0 */
		if (numTermR == 0) return 1;
		assert(n > 0);
		const_iterator itrL = this->begin();
		const_iterator itrR = rhs.begin();

		/*
			ξʤΤȤȷ빽®ʤ
		*/
		if (considerNumTerm) {
			if (numTermL != numTermR) return numTermL - numTermR;
		}

		for (size_t i = 0; i < n; i++) {
			int ret = itrL->isGreater(*itrR); /* ñ༰ν */
			if (ret != 0) return ret;
			++itrL;
			++itrR;
		}
		if (numTermL > numTermR) {
			return 1;
		}
		if (numTermL < numTermR) {
			return -1;
		}
		return 0;
	}

	/**
		ξΤ꾮Ȥ
	*/
	inline int isGreaterByNumTerm(const F2poly& rhs) const
	{
		return isGreater(rhs, true);
	}

	inline bool operator<(const F2poly& rhs) const
	{
//		return isGreater(rhs, true) < 0; /* PairSetǴְ㤨뤳Ȥ */
		return isGreater(rhs) < 0;
	}

	/*
		isGreater()ϰפƤ뤫ݤΤߤˤϽŤ
	*/
	inline bool operator==(const F2poly& rhs) const
	{
		/* Ŭǽ */
		return isGreater(rhs) == 0;
	}
	/*
		operator!=
	*/
	inline bool operator!=(const F2poly& rhs) const {
		return !operator==(rhs);
	}
	
	/**
		(Ū)ɲ
		@note Ǥ¸ߤƤƤäʤ(+=Ȥϰۤʤ)
	*/
	inline void addUnique(F2term const& t) {
#ifdef USE_SET
		insert(t);
#else
		for (iterator itr = begin(); itr != end(); ++itr) {
			if(t < *itr) continue;
			if(t > *itr) {
				insert(itr, t);
				MAX_ASSERT(isValid());
			}
			return;
		}
		push_back(t); /* ־äΤǺǸ˲ä */
		MAX_ASSERT(isValid());
#endif
	}
	
	/**
		(Ū)ɲ
		@note Ǥ¸ߤƤƤäʤ(+=Ȥϰۤʤ)
	*/
	inline void addUnique(F2poly const& rhs) {
		if(this == &rhs) return;
		
		iterator i1 = begin();
		const_iterator i2 = rhs.begin();
		while(i1 != end() && i2 != rhs.end()) {
			if(*i1 > *i2) ++i1;
			else if(*i1 < *i2) {
				i1 = insert(i1, *i2++);
				++i1;
			} else {
				++i1;
				++i2;
			}
		}
#ifdef USE_SET
		for(; i2 != rhs.end(); ++i2) insert(end(), *i2);
#else
		insert(end(), i2, rhs.end());
#endif
	}
	
	/**
		
	 */
	typedef F2poly::const_iterator terms;
	terms first() const { return begin(); }
	terms last() const { return end(); }
	
	/**
	 *this 顢rhs˴ޤޤʤ򿷤롣
	*/
	F2poly notIn(F2poly const& rhs) const {
		F2poly ret;
		const_iterator i1 = begin();
		const_iterator i2 = rhs.begin();
		while(i1 != end() && i2 != rhs.end()) {
			if(*i1 > *i2) {
			       ret.insert(ret.end(), *i1);
			       ++i1;
			} else if(*i1 < *i2) ++i2;
			else {
				++i1;
				++i2;
			}
		}
#ifdef USE_SET
		for(; i1 != end(); ++i1) ret.insert(ret.end(), *i1);
#else
		ret.insert(ret.end(), i1, end());
#endif
		return ret;
	}
	
	F2poly const& mulTopHigh(F2term r) {
		if(isZero()) return *this;
		F2term lm = LM();
		operator-=(lm);
		operator*=(r);
		r *= lm;
		r.makeHigh();
		operator+=(r);
		return *this;
	}
	
	void replaceTerm(F2term const& t, F2term const& s) {
		iterator i;
		for(i = begin(); i != end(); ++i) {
			if(*i == t) break;
		}
		if(i == end()) return;
		erase(i);
		operator+=(s);
	}
	
	inline void makeHigh(F2poly const& rhs) {
		if(this == &rhs) return;
		
		F2poly x;
		iterator i1 = begin();
		const_iterator i2 = rhs.begin();
		while(i1 != end() && i2 != rhs.end()) {
			if(*i1 > *i2) ++i1;
			else if(*i1 < *i2) ++i2;
			else {
				x.insert(x.end(), *i1);
				iterator ix = x.end(); --ix;
				const_cast<F2term&>(*ix).makeHigh();
				erase(i1++);
				++i2;
			}
		}
		operator+=(x);
	}
	
	inline void addTail(F2term const& t) { insert(end(), t); }
	
	void pullUp() {
		for(iterator i = begin(); i != end(); ++i) {
			if(i->isHigh()) const_cast<F2term&>(*i).makeHigh();
		}
	}
	
	void zero() { clear(); }
	
	/**
	  ԥ٥ȥؤѴ
	  *thisȤơfιԥ٥ȥɽ
	  @note: *pˤ*thisιХʬ0ꥢƤ뤳
	*/
	void getVector(F2poly const& f, char *p) const {
		const_iterator i1 = begin();
		const_iterator i2 = f.begin();
		while(i1 != end() && i2 != f.end()) {
			if(*i1 > *i2) {
			       ++i1;
			       ++p;
			} else if(*i1 < *i2) ++i2;
			else {
				*p++ = 1;
				++i1;
				++i2;
			}
		}
	}
#ifdef USE_SUGAR
	int sugar_;
#endif
	
private:
	/**
		ǧ
		@note normalize()Ƥ뤫ǧ
	*/
	inline bool isValid() const
	{
#ifdef USE_SET
		return true;
#else
		F2poly f = *this;
		f.normalize();
		return *this == f;
#endif
	}
};

/**
	
*/
std::ostream& operator<<(std::ostream& os, const F2poly& f)
{
	bool isFirst = true;
	for (F2poly::const_iterator itr = f.begin(); itr != f.end(); ++itr) {
		if (isFirst) {
			isFirst = false;
		} else {
			os << " + ";
		}
		os << *itr;
	}
	if (isFirst) {
		os << '0';
	}
	return os;
}

/**
	
	@note 顼ΤȤɤޤɤ߹ޤ줿
*/
std::istream& operator>>(std::istream& is, F2poly& f)
{
	f.clear();

	for (;;) {
		F2term x;
		is >> x;

		if (is.fail()) {
			break;
		}
		f += x;

		char c;
		is >> c;
		if (is.fail() || c != '+') {
			break;
		}
	}
//	f.normalize(); /*  */
	return is;
}

static void PutF2polySet(const F2poly::Set& G, char name = 'F')
{
	int i = 0;
	for (F2poly::Set::const_iterator itr = G.begin(); itr != G.end(); ++itr) {
		std::cout << name << '[' << std::setw(3) << i++ << "]=" << *itr << std::endl;
	}
}

#ifdef USE_MUL_F2TERM_SSE2
/*
	itrĸ˰ư
	ؿƤӽФF2termμΤؤΥݥ󥿤֤
*/
extern "C" void* incIter_C(F2poly::iterator *itr)
{
	void *p = (void*)&**itr;
	++(*itr);
	return p;
}
#endif

} // end of namespace

#endif /* F2POLY_H_ */
