#ifndef F2TERM_H_
#define F2TERM_H_
/**
	@file f2term.h
	@brief F2ñ༰饹ե
	@author $Author: herumi $
	@version $Revision: 1.21 $
	@date $Date: 2005/02/23 16:21:53 $
*/

#include <iostream>
#include <string>
#include <sstream>

namespace Hotaru {

/**
	F2ñ༰饹
	@note
	x_i^2 - x_iΥǥǳä;ΤߤͤΤǼ1ʲΤߥݡ
	0ɽȤϤǤʤ
*/
class F2term;
std::istream& operator>>(std::istream& is, F2term& x);

class F2term {
	friend class F2termx4;
#ifdef USE_PACKED_SUBSET_TYPE
	enum {
		/* subsetʬФΥޥ */
		SUBSET_MASK = (SUBSET_TYPE(1) << MAX_NUM_OF_VARIABLE) - 1,
		HIGH_BIT_MASK = 1 << 31
	};
	inline SUBSET_TYPE getRealSubset() const
	{
		return deg_subset_ & SUBSET_MASK;
	}
#else
	enum {
		SUBSET_MASK = SUBSET_TYPE(-1)
	};
#endif
public:
	enum {
		SUBSET_SIZE = sizeof(SUBSET_TYPE) * 8, /* byte = 8bits */
		NUM_SUBSET = (MAX_NUM_OF_VARIABLE + SUBSET_SIZE - 1) / SUBSET_SIZE,
		HIGH_BIT = MAX_NUM_OF_VARIABLE*2,	
		notInit = 1 /* ʤ󥹥ȥ饯 */
	};

	F2term()
	{
		setOne();
	}

	explicit F2term(int notInit)
	{
		/* ʤ */
	}

	/**
		ʸˤ
		ʸʤȤ
		@note F2polycstr̵ۣexplicit
		QQQ:ޤǤ?
	*/
	explicit F2term(const char* str)
	{
		std::istringstream istr(str);
		istr >> *this;
	}

#if 0
	/*
		ΤȤмˤʤɬפʤ
	*/
	F2term(const F2term& rhs)
	{
		copy(rhs);
		MAX_ASSERT(isValid());
	}
	F2term operator=(const F2term& rhs)
	{
		if (&(*this) != &rhs) {
			copy(rhs);
		}
		MAX_ASSERT(isValid());
		return *this;
	}
#endif
	/**
		i(0 <= i < N)ѿޤफ
		@param ix [in] ѿֹ
	*/
	inline bool hasVar(size_t i) const
	{
		assert(i < MAX_NUM_OF_VARIABLE);
#ifdef USE_PACKED_SUBSET_TYPE
		return (deg_subset_ & (SUBSET_TYPE(1) << i)) == 0;
#else
		return (subset_[i / SUBSET_SIZE] & (SUBSET_TYPE(1) << (i % SUBSET_SIZE))) == 0;
#endif
	}

	/**
		i(0 <= i < N)ѿ򥻥åȤ
		@param ix [in] ѿֹ
	*/
	inline void setVar(size_t i)
	{
		assert(i < MAX_NUM_OF_VARIABLE);

#ifdef USE_PACKED_SUBSET_TYPE
		SUBSET_TYPE testBit = SUBSET_TYPE(1) << i;
		if ((deg_subset_ & testBit) != 0) {
			deg_subset_ &= ~testBit;
			deg_subset_ += SUBSET_TYPE(1) << MAX_NUM_OF_VARIABLE;
		}
#else
		SUBSET_TYPE testBit = SUBSET_TYPE(1) << (i % SUBSET_SIZE);
		SUBSET_TYPE *target = &subset_[i / SUBSET_SIZE];

		if ((*target & testBit) != 0) {
			*target &= ~testBit;
			degree_++;
		}
#endif
		MAX_ASSERT(isValid());
	}

	/**
		i(0 <= i < N)ѿ򥯥ꥢ
	*/
	inline void clearVar(size_t i)
	{
		assert(i < MAX_NUM_OF_VARIABLE);

#ifdef USE_PACKED_SUBSET_TYPE
		SUBSET_TYPE testBit = SUBSET_TYPE(1) << i;
		if ((deg_subset_ & testBit) == 0) {
			deg_subset_ |= testBit;
			deg_subset_ -= SUBSET_TYPE(1) << MAX_NUM_OF_VARIABLE;
		}
#else
		SUBSET_TYPE testBit = SUBSET_TYPE(1) << (i % SUBSET_SIZE);
		SUBSET_TYPE *target = &subset_[i / SUBSET_SIZE];

		if ((*target & testBit) == 0) {
			*target |= testBit;
			degree_--;
		}
#endif
		MAX_ASSERT(isValid());
	}

	/**
		1ݤ
	*/
	inline bool isOne() const { return getDegree() == 0; }

	/**
		
		@retval  ѿθĿ
		@retval 0 1(ɸ2ʤΤ)
	*/

	inline int getDegree() const
	{
#ifdef USE_PACKED_SUBSET_TYPE
		return deg_subset_ >> MAX_NUM_OF_VARIABLE;
#else
		return degree_;
#endif
	}

	/**
		1
	*/
	inline void setOne()
	{
#ifdef USE_PACKED_SUBSET_TYPE
		deg_subset_  = SUBSET_MASK;
#else
		for (size_t i = 0; i < NUM_SUBSET; i++) {
			subset_[i] = SUBSET_TYPE(-1);
		}
		degree_ = 0;
#endif
		MAX_ASSERT(isValid());
	}

	/**
		
		ȤꤢDRL(degree reverse lexicographical ordering)

		@param rhs [in] 
		@retval  1 if this >  rhs
		@retval  0 if this == rhs
		@retval -1 if this <  rhs
		@note ӥåȤ0ΤȤѿȤ̣ˤΤ
		[degree:subset]ĤοͤȤӲǽǤ
		=> USE_PACKED_SUBSET_TYPEΰ̣

		0 < 1 < x_n < ... < x_1
	*/
	inline int isGreater(const F2term& rhs) const
	{
#if defined(USE_PACKED_SUBSET_TYPE)
		return deg_subset_ - rhs.deg_subset_;
#elif (NUM_SUBSET == 1)
//#define SPECIAL16
#ifdef SPECIAL16
		return (degree_ - rhs.degree_) << 16
			+ subset_[0] - rhs.subset_[0];
//			+ rhs.subset_[0] - this->subset_[0];
#else
		int ret = degree_ - rhs.degree_;
		if (ret) {
			return ret;
		} else {
			return subset_[0] - rhs.subset_[0];
		}
#endif
#else
		int lhsDeg = this->getDegree();
		int rhsDeg = rhs.getDegree();

		// 礭礭
		if (lhsDeg > rhsDeg) return 1;
		if (lhsDeg < rhsDeg) return -1;

		// ƱȤ礭x_j
		for (size_t i = NUM_SUBSET; i > 0; i--) {
			if (this->subset_[i - 1] > rhs.subset_[i - 1]) {
				return 1;
			}
			if (this->subset_[i - 1] < rhs.subset_[i - 1]) {
				return -1;
			}
		}
		return 0;
#endif
	}

	/*
		1ʤΤǽ => 
	*/
	inline bool operator==(const F2term& rhs) const
	{
		/* QQQ : Ŭǽ */
		return isGreater(rhs) == 0;
	}
	inline bool operator!=(const F2term& rhs) const
		{ return !operator==(rhs); }

	inline bool operator<(const F2term& rhs) const
	{
		return isGreater(rhs) < 0;
	}

	inline bool operator>(const F2term& rhs) const
	{
		return isGreater(rhs) > 0;
	}

	/**
		ret = a * b
		@note x_i^2 = x_i δطȤ2ʾι1ˤʤ
		ret, a, bƱΤؤƤƤOK
	*/
	static inline void mul(F2term& ret, const F2term& a, const F2term& b)
	{
		/*
			ݤȤȤѤȤȤ
		*/
#ifdef USE_PACKED_SUBSET_TYPE
		ret.deg_subset_ = (a.deg_subset_ & b.deg_subset_) & SUBSET_MASK;
		ret.deg_subset_ |= calcDegree(ret) << MAX_NUM_OF_VARIABLE;
#else
		for (size_t i = 0; i < NUM_SUBSET; i++) {
			ret.subset_[i] = a.subset_[i] & b.subset_[i];
		}
		ret.degree_ = calcDegree(ret);
#endif
		MAX_ASSERT(ret.isValid());
	}

	/**
		rhsݤ
		@note x_i^2 = x_i δطȤ2ʾι1ˤʤ
	*/
	inline F2term& operator*=(const F2term& rhs)
	{
		mul(*this, *this, rhs);
		return *this;
	}

	/**
		abǳڤ뤫
		@param a [in] 
		@param b [in] 
		@retval true if a can be devied by b
		@retval false if a can't be devied by b
	*/
	static inline bool canBeDividedBy(const F2term& a, const F2term& b)
	{
		/*
			bμ礭гʤ
		*/
		if (a.getDegree() < b.getDegree()) {
			return false;
		}

#ifdef USE_PACKED_SUBSET_TYPE
		return a.getRealSubset() == (a.getRealSubset() & b.getRealSubset());
#else
		/*
			bitȤabޤޤabǳ
		*/
		for (size_t i = 0; i < NUM_SUBSET; i++) {
			if (a.subset_[i] != (a.subset_[i] & b.subset_[i])) {
				return false;
			}
		}
#endif
		return true;
	}

	/**
		rhsǳڤ뤫
		@param rhs [in] 
		@retval true if this can be devied by rhs
		@retval false if this can't be devied by rhs
	*/
	inline bool canBeDividedBy(const F2term& rhs) const
	{
		return canBeDividedBy(*this, rhs);
	}

	/**
		ret = a / b;
		@param rhs [in] 
		@note ʤȤεư
		ret, a, bƱΤ򺹤ƤƤOK
	*/
	static inline void div(F2term& ret, const F2term& a, const F2term& b)
	{
		assert(canBeDividedBy(a, b));
#ifdef USE_PACKED_SUBSET_TYPE
		SUBSET_TYPE deg = a.getDegree() - b.getDegree();
		ret.deg_subset_ = (a.deg_subset_ | ~b.deg_subset_) & SUBSET_MASK;
		ret.deg_subset_ |= deg << MAX_NUM_OF_VARIABLE;
#else
		/*
			~bbitɲ
		*/
		for (size_t i = 0; i < NUM_SUBSET; i++) {
			ret.subset_[i] = a.subset_[i] | ~b.subset_[i];
		}
		/*
			rhsʬ
		*/
		ret.degree_ = a.degree_ - b.degree_;
#endif
		MAX_ASSERT(ret.isValid());
	}
	/**
		rhsǳ
		@param rhs [in] 
		@note ʤȤޤrhs=0ΤȤεư
	*/
	inline F2term& operator/=(const F2term& rhs)
	{
		div(*this, *this, rhs);
		return *this;
	}

	/**
		abκǾܿ
		@note F2ʤΤǳݤƱ
	*/
	static inline F2term getLCM(const F2term& a, const F2term& b)
	{
		F2term ret(notInit);
		mul(ret, a, b);
		return ret;
	}

	/*
		abϸߤǤ
		@note orΤˤʤʤߤ
	*/
	static inline bool isPrimeTo(const F2term& a, const F2term& b)
	{
#ifdef USE_PACKED_SUBSET_TYPE
		return ((a.deg_subset_ | b.deg_subset_)) == SUBSET_MASK;
#else
		SUBSET_TYPE ret = SUBSET_MASK;
		for (size_t i = 0; i < NUM_SUBSET; i++) {
			ret &= (a.subset_[i] | b.subset_[i]);
		}
		return ret == SUBSET_MASK;
#endif
	}
	inline bool isPrimeTo(const F2term& rhs) const
	{
		return isPrimeTo(*this, rhs);
	}
private:
	/**
		subset_[0]ΰֲ(0bit)x_0
		subset_[0]1bitܤx_1
		...
		subset_[NUM_SUBSET - 1]31bitܤx_(MAX_NUM_OF_VARIABLE - 1)

		subset_[i]jbitܤx_{i * 32 + j}ɽ
		i = 0, ..., NUM_SUBSET - 1
		j = 0, ..., SUBSET_SIZE - 1
		@note DRLȽ꤬䤹褦(for x86)
		bitäƤȡѿ*̵*Ȥ̣롥
		̾ȵդǤ뤳Ȥդ롥

		ex) MAX_NUM_OF_VARIABLE = 128, SUBSET_SIZE = 32
		subset[0]   31 30 ....... 1 0
		subset[1]   63 62 ........ 32
		subset[2]   95 94 ........ 64
		subset[3]  127 126 ....... 96
	*/

#ifdef USE_PACKED_SUBSET_TYPE
	/*
		[high:deg:subset]
		high:31bit
		deg:2630bit
		subset:ӥåȤ*0*ʬѿ뤳Ȥ̣(ޤǤȵ)
	*/
	SUBSET_TYPE deg_subset_;
#define F2TERM_CALDEGTYPE 2  /* 0:normal 1:bit calc 2:table */
#ifdef MAIN_INSTANCE_HERE
#define F2TERM_NEED_INSTANCE
#endif
	static int const degtbl_[256];

	static inline int calcDegree(const F2term& x)
	{
		uint32 d = x.deg_subset_ & SUBSET_MASK;
		int deg = degtbl_[d & 0xFF];
		deg += degtbl_[((d >> 8) & 0xFF)];
		deg += degtbl_[(d >> 16) & 0xFF];
		/* QQQ:ˤƴְ㤤䤹ΤUSE_PACKED_SUBSET_TYPEǥեˤʤäȤϺ뤳 */
		deg += degtbl_[((d >> 24) & 0x3) | 0xFC];
		return deg;
	}
#else

	SUBSET_TYPE subset_[NUM_SUBSET];
	int degree_; /* degree == 0ΤȤ1ɽ */

#define F2TERM_CALDEGTYPE 2  /* 0:normal 1:bit calc 2:table */

#if F2TERM_CALDEGTYPE == 1
	/* 1θĿ */
	static inline size_t count1(uint32 x)
	{
#if 0 /* ̵ä... */
		x = x - ((x >> 1) & 0x55555555);
		x = (x & 0x33333333) + ((x >> 2) & 0x33333333);
		x = (x >> 4) + x;
		x &= 0x0F0F0F0F;
		x = (x >> 8) + x;
		x = ((x >> 16) + x) & 0x3F;
		return x;
#else
		x = (x & 0x55555555) + ((x >> 1) & 0x55555555);
		x = (x & 0x33333333) + ((x >> 2) & 0x33333333);
		x = (x & 0x0F0F0F0F) + ((x >> 4) & 0x0F0F0F0F);
		x = (x & 0x00FF00FF) + ((x >> 8) & 0x00FF00FF);
		x = (x & 0x0000FFFF) + (x >> 16);
		return x;
#endif
	}
	static inline size_t count1(uint64 x)
	{
		x = (x & 0x5555555555555555) + ((x >> 1) & 0x5555555555555555);
		x = (x & 0x3333333333333333) + ((x >> 2) & 0x3333333333333333);
		x = (x & 0x0F0F0F0F0F0F0F0F) + ((x >> 4) & 0x0F0F0F0F0F0F0F0F);
		x = (x & 0x00FF00FF00FF00FF) + ((x >> 8) & 0x00FF00FF00FF00FF);
		x = (x & 0x0000FFFF0000FFFF) + ((x >> 16) & 0x0000FFFF0000FFFF);
		x = uint32(x) + (x >> 32);
		return size_t(x);
	}
#endif

	/**
		˼
		@note Ŭǽ
	*/
#if F2TERM_CALDEGTYPE == 2
	static int const degtbl_[256];
#ifdef MAIN_INSTANCE_HERE
#define F2TERM_NEED_INSTANCE
#endif
	static inline int calcDegree(const F2term& x)
	{
		int degree = 0;
		unsigned char const *p = (unsigned char const*)x.subset_;
		for(size_t i = 0; i < NUM_SUBSET*sizeof(SUBSET_TYPE); ++i) {
			degree += degtbl_[p[i]];
		}
		return degree;
	}
#endif


#if F2TERM_CALDEGTYPE <= 1
	static inline int calcDegree(const F2term& x)
	{
		int degree = 0;
		for (size_t j = 0; j < NUM_SUBSET; j++) {
			SUBSET_TYPE val = x.subset_[j];
#if F2TERM_CALDEGTYPE == 1
			degree += count1(~val);
#else
			for (size_t i = 0; i < SUBSET_SIZE; i++) {
				if ((val & (SUBSET_TYPE(1) << i)) == 0) {
					degree++;
				}
			}
#endif
		}
		return degree;
	}
#endif

#endif /* USE_PACKED_SUBSET_TYPE */

	inline int calcDegree() const { return calcDegree(*this); }

	/**
		ǧ
		@note degree >= 0ΤȤsubsetbitοפƤ뤫
		ǤʤȤsubset0
	*/
	inline bool isValid() const
	{
#ifdef USE_PACKED_SUBSET_TYPE
		return getDegree() == calcDegree();
#else
		return ((degree_ + HIGH_BIT)%(int)HIGH_BIT) == calcDegree();
#endif
	}
	
public:
	inline void makeHigh() {
#ifdef USE_PACKED_SUBSET_TYPE
		deg_subset_ |= SUBSET_TYPE(HIGH_BIT_MASK);
#else
		degree_ += HIGH_BIT;
#endif
	}
	
	inline void makeLow() {
#ifdef USE_PACKED_SUBSET_TYPE
		deg_subset_ &= ~HIGH_BIT_MASK;
#else
		degree_ -= HIGH_BIT;
#endif
	}
	
	inline void clearHigh() {
#ifdef USE_PACKED_SUBSET_TYPE
		deg_subset_ &= ~HIGH_BIT_MASK;
#else
		degree_ %= HIGH_BIT;
#endif
	}
	
	inline bool isHigh() const {
#ifdef USE_PACKED_SUBSET_TYPE
		return (deg_subset_ & SUBSET_TYPE(HIGH_BIT_MASK)) != 0;
#else
		return degree_ >= (int)HIGH_BIT;
#endif
	}
	
	inline bool isLow() const {
#ifdef USE_PACKED_SUBSET_TYPE
		/* ֤­ʤä */
//		return (deg_subset_ & SUBSET_TYPE(HIGH_BIT_MASK)) == 0;
		assert(0);
		return false;
#else
		return degree_ < 0;
#endif
	}
	
private:
	inline void copy(const F2term& rhs)
	{
		memcpy(this, &rhs, sizeof(F2term));
	}
};

static inline F2term operator*(const F2term& a, const F2term& b)
{
	F2term ret(F2term::notInit);
	F2term::mul(ret, a, b);
	return ret;
}

static inline F2term operator/(const F2term& a , const F2term& b)
{
	F2term ret(F2term::notInit);
	F2term::div(ret, a, b);
	return ret;
}

/* MAPLE */
/* MAPLEξx[0]ϻȤʤΤx[1]Ϥ */
static std::ostream& F2termOutputMAPLE(std::ostream& os, const F2term& x)
{
	if (x.getDegree() == 0) {
		os << '1';
	} else {
		bool isFirst = true;
		for (size_t i = 0; i < MAX_NUM_OF_VARIABLE; i++) {
			if (x.hasVar(i)) {
				if (isFirst) {
					isFirst = false;
				} else {
					os << " * ";
				}
				os << "x[" << (i + 1) << ']';
			}
		}
	}
	return os;
}

/* SIMPLE */
static std::ostream& F2termOutputSIMPLE(std::ostream& os, const F2term& x)
{
	if (x.getDegree() == 0) {
		os << '1';
	} else {
		bool isFirst = true;
		os << '(';
		for (size_t i = 0; i < MAX_NUM_OF_VARIABLE; i++) {
			if (x.hasVar(i)) {
				if (isFirst) {
					isFirst = false;
				} else {
					os << ", ";
				}
				os << i;
			}
		}
		os << ')';
	}
	return os;
}

/* ALPHABET */
static std::ostream& F2termOutputALPHABET(std::ostream& os, const F2term& x)
{
	if (x.getDegree() == 0) {
		os << '1';
	} else {
		for (size_t i = 0; i < ALPHABET_NUM; i++) {
			if (x.hasVar(i)) {
				char c = static_cast<char>('a' + i);
				os << c;
			}
		}
		for (size_t i = ALPHABET_NUM; i < MAX_NUM_OF_VARIABLE; i++) {
			if (x.hasVar(i)) {
				std::cerr << "can't display!" << std::endl;
			}
		}
	}
	if(x.isHigh()) {
		os << '(' << (x.getDegree()/F2term::HIGH_BIT) << ')';
	} else if(x.isLow()) {
		os << '(' << ((x.getDegree()+1)/F2term::HIGH_BIT - 1) << ')';
	}
	return os;
}

/**
	
*/
static std::ostream& operator<<(std::ostream& os, const F2term& x)
{
	switch (OutputFormatType) {
	case MAPLE:
		return F2termOutputMAPLE(os, x);
	case SIMPLE:
		return F2termOutputSIMPLE(os, x);
	case ALPHABET:
		return F2termOutputALPHABET(os, x);
	default:
		assert(0);
		return os;
	}
}

/**
	SIMPLE 
	@note 顼ΤȤɤޤɤ߹ޤ줿
	:
	1(1)
	(1) x[1]
	(1, 3, 5) x[1] * x[3] * x[5]
	0
*/
static std::istream& F2termInputSIMPLE(std::istream& is, F2term& x)
{
	x.setOne();

	int num;
	is >> num;

	if (!is.fail()) { /* ʸФǤ */
		if (num != 1) {
			if (debug) std::cerr << "F2term error(SIMPLE): illegal const[" << num << "]\n";
		}
	} else {
		is.clear();
		char c;
		is >> c;
		if (c != '(') {
			if (debug) std::cerr << "F2term error: illegal char[" << c << "]\n";
		} else {
			for (;;) {
				size_t idx;
				is >> idx;
				if (is.fail()) {
					if (debug) std::cerr << "F2term error: not number\n";
					break;
				}
				if (idx >= MAX_NUM_OF_VARIABLE) {
					if (debug) std::cerr << "F2term error: illegal idx=" << idx << std::endl;
					break;
				}
				x.setVar(idx);
				is >> c;
				if (c == ')') {
					break;
				}
				if (c != ',') {
					if (debug) std::cerr << "F2term error: not comma\n";
					break;
				}
			}
		}
	}
	std::cout << "[[" << x << "]]\n";
	return is;
}

/**
	ALPHABET 
	ڡ*̵ ()ȤäƤϤʤ
	:
	a, ab, 1, a bc, a*b*c : OK
	(a), (abc): NG
	@note *̵뤹ʤΤa*b*⤢ˤʤäƤޤ
*/
std::istream& F2termInputALPHABET(std::istream& is, F2term& x)
{
	x.setOne();

	int num;
	is >> num;

	if (!is.fail()) { /* ʸФǤ */
		if (num != 1) {
			if (debug) std::cerr << "F2term error(ALPHABET): illegal const[" << num << "]\n";
		}
	} else {
		is.clear();

		for (;;) {
			char c;
			is >> c;
			if (!is.fail() && c == '*') continue; /* ̵ */
			if (!is.fail() && 'a' <= c && c <= 'z') {
				size_t idx = c - 'a';
				x.setVar(idx);
			} else {
				is.clear();
				is.putback(c);
				break;
			}
		}
	}
	return is;
}

std::istream& operator>>(std::istream& is, F2term& x)
{
	switch (InputFormatType) {
	case MAPLE:
		std::cerr << "not support" << std::endl;
		return is;
	case SIMPLE:
		return F2termInputSIMPLE(is, x);
	case ALPHABET:
		return F2termInputALPHABET(is, x);
	default:
		assert(0);
		return is;
	}
}

/**
	ϥեޥåѹޥ˥ԥ졼
	asMAPLE, asSIMPLE, asALPHABET
*/
#define DEFINE_IN_MANIPULATOR(type) std::istream& as ## type(std::istream& is) { InputFormatType = type; return is; }
#define DEFINE_OUT_MANIPULATOR(type) std::ostream& as ## type(std::ostream& os) { OutputFormatType = type; return os; }

DEFINE_OUT_MANIPULATOR(MAPLE)
DEFINE_OUT_MANIPULATOR(SIMPLE)
DEFINE_OUT_MANIPULATOR(ALPHABET)

DEFINE_IN_MANIPULATOR(MAPLE)
DEFINE_IN_MANIPULATOR(SIMPLE)
DEFINE_IN_MANIPULATOR(ALPHABET)

#undef DEFINE_IN_MANIPULATOR
#undef DEFINE_OUT_MANIPULATOR

/**
	Ūѹؿ
*/
static inline void changeOutputFormat(FormatType type)
{
	OutputFormatType = type;
}

static inline void changeInputFormat(FormatType type)
{
	InputFormatType = type;
}

#ifdef F2TERM_NEED_INSTANCE
int const F2term::degtbl_[256] = {
#if 1 /* ӥåȤ0θĿ */
	8, 7, 7, 6, 7, 6, 6, 5, 7, 6, 6, 5, 6, 5, 5, 4,
	7, 6, 6, 5, 6, 5, 5, 4, 6, 5, 5, 4, 5, 4, 4, 3,
	7, 6, 6, 5, 6, 5, 5, 4, 6, 5, 5, 4, 5, 4, 4, 3,
	6, 5, 5, 4, 5, 4, 4, 3, 5, 4, 4, 3, 4, 3, 3, 2,
	7, 6, 6, 5, 6, 5, 5, 4, 6, 5, 5, 4, 5, 4, 4, 3,
	6, 5, 5, 4, 5, 4, 4, 3, 5, 4, 4, 3, 4, 3, 3, 2,
	6, 5, 5, 4, 5, 4, 4, 3, 5, 4, 4, 3, 4, 3, 3, 2,
	5, 4, 4, 3, 4, 3, 3, 2, 4, 3, 3, 2, 3, 2, 2, 1,
	7, 6, 6, 5, 6, 5, 5, 4, 6, 5, 5, 4, 5, 4, 4, 3,
	6, 5, 5, 4, 5, 4, 4, 3, 5, 4, 4, 3, 4, 3, 3, 2,
	6, 5, 5, 4, 5, 4, 4, 3, 5, 4, 4, 3, 4, 3, 3, 2,
	5, 4, 4, 3, 4, 3, 3, 2, 4, 3, 3, 2, 3, 2, 2, 1,
	6, 5, 5, 4, 5, 4, 4, 3, 5, 4, 4, 3, 4, 3, 3, 2,
	5, 4, 4, 3, 4, 3, 3, 2, 4, 3, 3, 2, 3, 2, 2, 1,
	5, 4, 4, 3, 4, 3, 3, 2, 4, 3, 3, 2, 3, 2, 2, 1,
	4, 3, 3, 2, 3, 2, 2, 1, 3, 2, 2, 1, 2, 1, 1, 0,
#else
 0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4,
 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
 4, 5, 5, 6, 5, 6, 6, 7, 5, 6, 6, 7, 6, 7, 7, 8,
#endif
};
#endif
} // end of namespace

#endif /* F2TERM_H_ */
