#ifndef F2TERMX4_H_
#define F2TERMX4_H_
/**
	@file f2termx4.h
	@brief F2ñ༰饹x4
	@author $Author: herumi $
	@version $Revision: 1.1 $
	@date $Date: 2005/02/15 16:26:34 $
	@note MAX_NUM_OF_VARIABLE == 32x86 SSE2(ϰ¸)
*/

#include <emmintrin.h>

namespace Hotaru {

/* _mm_*()ϤˤͤʤȤߤ */
template<int x, int y, int z, int w>
struct PACK {
	enum {
		value = x * 64 + y * 16 + z * 4 + w
	};
};

/*
	ͤĤޤȤƱ黻
	[a:b:c:d] * d  [a*t:b*t:c*t:d*t]
*/
class F2termx4 {
private:
#if 0
	static inline int PACK(int x, int y,int z,int w)
	{
		return x * 64 + y * 16 + z * 4 + w;
	}
#endif

public:
	F2termx4(F2term *x[4])
	{
		uint32 *p = (uint32*)&subset_;
		subset_ = _mm_set_epi32(x[3]->subset_[0], x[2]->subset_[0], x[1]->subset_[0], x[0]->subset_[0]);
	}
	inline void mul(F2term& t)
	{
		static const __m128i c55555555 = _mm_set_epi32(0x55555555, 0x55555555, 0x55555555, 0x55555555);
		static const __m128i c33333333 = _mm_set_epi32(0x33333333, 0x33333333, 0x33333333, 0x33333333);
		static const __m128i c0F0F0F0F = _mm_set_epi32(0x0F0F0F0F, 0x0F0F0F0F, 0x0F0F0F0F, 0x0F0F0F0F);
		static const __m128i c00FF00FF = _mm_set_epi32(0x00FF00FF, 0x00FF00FF, 0x00FF00FF, 0x00FF00FF);
		static const __m128i c0000FFFF = _mm_set_epi32(0x0000FFFF, 0x0000FFFF, 0x0000FFFF, 0x0000FFFF);
		__m128i x, y, v;
		x = _mm_set1_epi32(t.subset_[0]); // x = [t:t:t:t]
//		x = _mm_shuffle_epi32(x, PACK<3, 3, 3, 3>::value); // x = [t:t:t:t]
		x = _mm_or_si128(x, subset_); // [subset] * [t:t:t:t:]
		v = x;

		// bit count
		// step1
		y = _mm_and_si128(x, c55555555);
		x = _mm_srli_epi32(x, 1);
		x = _mm_and_si128(x, c55555555);
		x = _mm_add_epi32(x, y);
		// step2
		y = _mm_and_si128(x, c33333333);
		x = _mm_srli_epi32(x, 2);
		x = _mm_and_si128(x, c33333333);
		x = _mm_add_epi32(x, y);
		// step3
		y = _mm_and_si128(x, c0F0F0F0F);
		x = _mm_srli_epi32(x, 4);
		x = _mm_and_si128(x, c0F0F0F0F);
		x = _mm_add_epi32(x, y);
		// step4
		y = _mm_and_si128(x, c00FF00FF);
		x = _mm_srli_epi32(x, 8);
		x = _mm_and_si128(x, c00FF00FF);
		x = _mm_add_epi32(x, y);
		// step5
		y = _mm_and_si128(x, c0000FFFF);
		x = _mm_srli_epi32(x, 16);
		x = _mm_and_si128(x, c0000FFFF);
		y = _mm_add_epi32(x, y);

		// shuffle
		__m128i z, w;
		z = _mm_unpacklo_epi32(v, y);
		w = _mm_unpackhi_epi32(v, y);

		_mm_store_si128(&subset_, z);
		_mm_store_si128(&degree_, w);
	}
	inline F2term get(int idx) const
	{
//		return *(reinterpret_cast<F2term*>(&subset_) + idx);
		return *((F2term*)&subset_ + idx);
	}
private:
	__m128i subset_;
	__m128i degree_;
};

} // end of namespace

#endif /* F2TERMX4_H_ */
