#ifndef HOTARU_CONFIG_H_
#define HOTARU_CONFIG_H_

/**
	@file hotaru_config.h
	@brief ֥ʡե
	@author $Author: herumi $
	@version $Revision: 1.28 $
	@date $Date: 2005/02/23 16:21:53 $
*/
#ifdef _MSC_VER
	#pragma warning(disable : 4530) /* 㳰Ȥʤ */
	#define NOUSE_MYALLOC_TRAITS
#endif

#ifdef __BORLANDC__
	#pragma warn -8027 /* 饤ؿˤǤʤ */
	#pragma warn -8066 /* ¹Ԥʤ */
	#pragma warn -8008 /* 郎˿ */
#endif

#include "mie_common.h"
#include <cassert>
#include <cstdlib>

namespace Hotaru {

const int VERSION = 0x0100; /* 0xHHLL => ver. HH.LL */

/*
	ǥХåå
	0 : no debug message
	1 : print debug message
	2 : more
	3 : code check
	4 : all
*/
#ifdef NDEBUG
const int debug = 0;
#else
const int debug = 1;
#endif
/* debug < 3ʤ̵ */
#define WARN_ASSERT(x) assert(!(debug < 3) || (x))
/* debug < 4ʤ̵ */
#define MAX_ASSERT(x) assert(!(debug < 4) || (x))

/* x == true ʤʤ */
#define CODE_ASSERT(x) assert(!Hotaru::code_debug || (x))
#define ALGO_ASSERT(x) assert(!Hotaru::algo_debug || (x))

/*
	HIGH_BIT + degree + MAX_NUM_OF_VARIABLE = sizeof(utin32) * 8Ȥʤ褦
	ɽѤ(1 + 5 + 26 = 32)
*/
//#define USE_PACKED_SUBSET_TYPE
//#define USE_HL

/*
	F2ñ༰ɽκǾñ
*/
#ifdef __amd64__
	//typedef uint64 SUBSET_TYPE;
	typedef uint32 SUBSET_TYPE;
#else	
	typedef uint32 SUBSET_TYPE;
#endif

/* ¿༰Ĥѿο(Nɽ:SUBSET_TYPEΥӥåĹܿǤ뤳) */
#ifdef USE_PACKED_SUBSET_TYPE
	const size_t MAX_NUM_OF_VARIABLE = 26; /* ѹԲ */
#else
	//const size_t MAX_NUM_OF_VARIABLE = 128;
	const size_t MAX_NUM_OF_VARIABLE = sizeof(SUBSET_TYPE)*8;
#endif

enum FormatType {
	MAPLE, /*!< MapleŪ(x[1] * x[2] * x[3]) */
	SIMPLE, /*!< (1, 2, 3)ߤɽ */
	ALPHABET /*!< abcߤɽ(126ޤǤбʤ:׻) */
};

const size_t ALPHABET_NUM = 26;

/*
	ѿ26ĤޤǤ¤ΤunitƥȤǤ ALPHABET ϻȤʤ褤
*/
//FormatType InputFormatType = ALPHABET;
FormatType InputFormatType = SIMPLE;
FormatType OutputFormatType = SIMPLE;

/*
	ƥʤμѹ
*/
#define USE_MYLIST
//#define USE_MYSET
//#define USE_MYALLOC
//#define USE_SET
//#define USE_BOOST
enum { POOL_NODE_NUM = 1500000 };
enum { POOL_PAIR_NUM = 100000 };
enum { MAX_PE_ID = 1024 };

/* ɤ餫ĤȤʤ */
#if defined(USE_MYLIST) && defined(USE_MYSET)
	#error "you can use only one container"
#endif

/* USE_MYSETȤʤUSE_SETϼưŪ */
#ifdef USE_MYSET
	#ifndef USE_SET
		#define USE_SET
	#endif
#endif

/* ꥸʥ륢ȥꥸʥ륳ƥʤ϶¸Ǥʤ */
#if defined(USE_MYLIST) || defined(USE_MYSET)
	#ifdef USE_MYALLOC
		#error "you can't use myalloc with mylist/myset"
	#endif
#endif

/* ι®() */
//#define USE_MUL_F2TERM_SSE2 /* x86F2term x 4ݤ */

} // end of namespace

#endif /* HOTARU_CONFIG_H_ */
