#ifndef HTOARU_PAIR_SET_H_
#define HTOARU_PAIR_SET_H_
/**
	@file hotaru_pair.h
	@brief ڥ륰֥ʡ׻ġ
	@author $Author: herumi $
	@version $Revision: 1.14 $
	@date $Date: 2005/02/24 16:01:23 $
*/

#include <set>
#include <map>
#include <algorithm>
#include <functional>

namespace Hotaru {


namespace PairSet {

const char* getString() { return "PairSet"; }

bool inline compareStrategy(const F2poly*const& lhs, const F2poly*const& rhs)
{
	return lhs->isGreaterByNumTerm(*rhs) < 0;
}

struct compareByNumTerm : public std::binary_function<F2poly*, F2poly*, bool> {
	bool operator()(const F2poly*const& lhs, const F2poly*const& rhs) const
	{
		return compareStrategy(lhs, rhs);
	}
};


struct PolyPair {
	const F2poly* f_;
	const F2poly* g_;
	/* f < g Ȥ */
	PolyPair(const F2poly* f = 0, const F2poly* g = 0)
	{
		if (f < g) {
			f_ = f, g_ = g;
		} else {
			f_ = g, g_ = f;
		}
	}
	bool operator<(const PolyPair& rhs) const
	{
		int ret = f_->isGreaterByNumTerm(*rhs.f_);
		if (ret < 0 || (ret == 0 && g_->isGreaterByNumTerm(*rhs.g_) < 0)) {
			return true;
		}
		return false;
	}
};

std::ostream& operator<<(std::ostream& os, const PolyPair& pair)
{
	os << '(' << *(pair.f_) << ", " << *(pair.g_) << ')';
	os << "    (" << pair.f_ << ", " << pair.g_ << ')';
	return os;
}
/*
	ڥμά
	F2polyΥݥ󥿤ǻäƤΤΤν˾ɽʤȤʤ
	weak_ptrʤɻȤäڤ
*/
class PairStrategy {
private:
	/*
		Sij
	*/
	/*
		άˤäƥڥŬʽ
	*/
	typedef std::set<PolyPair> PolyPairList;
	PolyPairList Sij_;

const F2poly::Set* pG_;
	
public:
	/*
		F2termϳF2polyФSi()åȤΥե饰ݤ
		˻Ȥ
	*/
	typedef std::map<const F2poly*, F2term, compareByNumTerm> OrderedSet;
	OrderedSet orderedG_; /* ά˽ä¤٤줿G */

	/*
		ߤorderdGfΥڥ
	*/
	inline void addLine(const F2poly& f, OrderedSet::const_iterator begin, PolyPairList::const_iterator& hint)
	{
		const F2term& LMf = f.LM();
		for (OrderedSet::const_iterator itr = begin; itr != orderedG_.end(); ++itr) {
			if (LMf.isPrimeTo((*itr->first).LM())) {
				continue;
			}
			PolyPair pair(itr->first, &f);
//			assert(Sij_.find(pair) == Sij_.end()); /* ƤΤϤ */
#if 1
			PolyPairList::const_iterator tmp;
//			std::cout << "addLine:" << pair << std::endl;
			if ((tmp = Sij_.find(pair)) != Sij_.end()) {
				std::cout << "itr=" << *(itr->first) << ", " << f << std::endl;
				exit(1);
			}
#endif
			hint = Sij_.insert(hint, pair);
		}
	}

	inline void init(const F2poly::Set& G)
	{
pG_ = &G;
		/*
			zeroF2termȤƤǤϤʤMAX_NUM_OF_VARIABLEĤbool
			ͤȤѤ
		*/
		F2term zero;
		/* G¤ؤ */
		for (F2poly::Set::const_iterator itr = G.begin(); itr != G.end(); ++itr) {
			orderedG_[&*itr] = zero;
		}
		/* ڥμ */
		OrderedSet::const_iterator i, j, prevEndG = orderedG_.end();
		--prevEndG;
		PolyPairList::const_iterator hint = Sij_.begin();
		for (i = orderedG_.begin(); i != prevEndG; ++i) { // i = 0; i < m - 1; i++
			j = i, ++j;
			addLine(*(i->first), j, hint);
		}
	}

	/*
		GfɲäȤƤӽФ
	*/
	inline void add(const F2poly& f)
	{
		assert(orderedG_.find(&f) == orderedG_.end());
///
puts("---------add in");
		for (OrderedSet::const_iterator i = orderedG_.begin(); i != orderedG_.end(); ++i) {
			printf("[%p]\n", i->first);
		}
printf("&f=%p, orderedG_.find=%p, end=%p\n", &f, orderedG_.find(&f), orderedG_.end());
		if (orderedG_.find(&f) != orderedG_.end()) {
			printf("already add %p\n", &f);
			exit(1);
		}
///
		PolyPairList::const_iterator hint = Sij_.begin();
		addLine(f, orderedG_.begin(), hint);
printf("add %p\n", &f);
puts("---------add out");
		orderedG_[&f] = F2term();
	}

	/*
		GfȤƤӽФ
	*/
	inline void erase(const F2poly& f)
	{
		PolyPairList::iterator itr = Sij_.begin();
		while (itr != Sij_.end()) {
			if (itr->f_ == &f || itr->g_ == &f) {
				Sij_.erase(itr++);
			} else {
				++itr;
			}
		}
printf("del %p\n", &f);
		int removedNum = orderedG_.erase(&f);
		assert(removedNum == 1);
		if (removedNum != 1) {
			printf("removedNum=%d\n", removedNum);
		}
	}
	/*
		ڥļФ
	*/
	inline bool getPair(PolyPair& pair)
	{
		if (Sij_.size()) {
			pair = *Sij_.begin();
			Sij_.erase(Sij_.begin());
			return true;
		}
		return false;
	}

	/*
		ǥХå
	*/
	void put() const
	{
		puts("<<<<<<<<<<<<<<<<<<<<<<<<<");
		for (OrderedSet::const_iterator i = orderedG_.begin(); i != orderedG_.end(); ++i) {
			printf("[%p]\n", i->first);
		}
		for (OrderedSet::const_iterator i = orderedG_.begin(); i != orderedG_.end(); ++i) {
			const F2term& LMs = i->first->LM();

//			printf("[[%p]]\n", i->first);

			for (size_t j = 0; j < Hotaru::MAX_NUM_OF_VARIABLE; j++) {
				if (!LMs.hasVar(j)) {
					continue;
				}
				if (i->second.hasVar(j)) {
					continue;
				}
				std::cout << "Si(" << *(i->first) << ", " << j << ")\n";
				printf("(%p, %d)\n", i->first, j);
			}
		}
		for (PolyPairList::iterator itr = Sij_.begin(); itr != Sij_.end(); ++itr) {
			printf("(%p, %p)\n", itr->f_, itr->g_);
//			std::cout << "Sij(" << *itr->f_ << ", " << *itr->g_ << ")\n";
		}
		puts(">>>>>>>>>>>>>>>>>>>>>>>>>");
	}
	size_t getNumOfSij() const { return Sij_.size(); }
};

/**
	G = {g1, ..., gm}֥ʡ줫ݤ
	@note Gϴޤޤʤ
	@param G [in] Ƚꤷ¿༰
	@param s [out] Ƚ˼ԤS¿༰
	@note X^2 + Xηۤ˴ޤޤƤΤǡ
	ȤSpolyˤĤƤͤɬפ롥
	LM(f)x_iޤȤS(f, x_i^2+x_i)=x_i fȤʤ롥
*/
static bool IsGbase(const F2poly::Set& G, F2poly& s, PairStrategy& strategy)
{
	bool isFirst = true;
	strategy.put();
RETRY:
	/**
		X^2 + XȤSpolyͤ
		f2poly.hisGreater()numTermӤ򤹤
		˸ƤӽФä®ʤ
	*/
	for (PairStrategy::OrderedSet::iterator i = strategy.orderedG_.begin(); i != strategy.orderedG_.end(); ++i) {
		const F2term& LMs = i->first->LM();

		for (size_t j = 0; j < Hotaru::MAX_NUM_OF_VARIABLE; j++) {
			if (!LMs.hasVar(j)) {
				continue;
			}
			if (i->second.hasVar(j)) {
				continue;
			}
			i->second.setVar(j);
			s = F2poly::GetSpoly(*(i->first), j);
			s.dividedBy(G);
			if (!s.isZero()) {
//std::cout << "Si(" << *(i->first) << ", " << j << ")=" << s << std::endl;
				return false;
			}
		}
	}

	PolyPair pair;
	while (strategy.getPair(pair)) {
		if (!pair.f_->isZero() && !pair.g_->isZero()) {
			s = F2poly::GetSpoly(*pair.f_, *pair.g_);
			s.dividedBy(G);
			if (!s.isZero()) {
//std::cout << "Sij(" << pair << "\n";
				return false;
			}
		}
	}
	/*
		ڥ̵ʤäƤޤSiǤ뤫⤷ʤ
		礷
	*/
	if (isFirst) {
		isFirst = false;
		puts("Retry");
		goto RETRY;
	}
	return true;
}

static inline bool isCorrectGreater(const F2poly& lhs, const F2poly& rhs)
{
	return lhs.isGreater(rhs, false) < 0;
}

/*
	ξ¤ؤ
	0ƱΤϺ
*/
static void sortAndRemoveTrivialPoly(F2poly::Set& G, PairStrategy& strategy)
{
//	G.sort(isCorrectGreater); /* ξ¤ؤ */
	G.sort(); /* ξ¤ؤ */

#if 0
	G.unique(); /* ƱΤϺ */
#else
	F2poly::Set::iterator i;
	i = G.begin();
	do {
		if (i == G.end()) break;
		F2poly::Set::iterator j = i;
		++j;
		while (j != G.end() && *i == *j) {
			strategy.erase(*j);
			G.erase(j++);
		}
		++i;
	} while (i != G.end());
#endif

	/* 0 */
	i = G.begin();
	while (i != G.end()) {
		if (i->isZero()) {
			strategy.erase(*i);
			G.erase(i++);
		} else {
			++i;
		}
	}
	/* 1ޤtrivial */
	if (G.size() > 0 && G.begin()->getMltDeg() == 0) {
		G.clear();
		G.push_back(F2poly(F2term())); /* = 1 */
	}
}

/**
	ľʹ
	@param G [in] ֥ʡ
	@note LMߤפʹ
*/
static void Simplify(F2poly::Set& G, PairStrategy& strategy)
{
	sortAndRemoveTrivialPoly(G, strategy);

	/* ब2İʾʤнλ */
	if (G.size() < 2) {
		return;
	}

	/*
		˳äƤߤ
	*/
	F2poly::Set::iterator i, j, prevEndG = G.end();
	--prevEndG;

	for (i = G.begin(); i != prevEndG; ++i) { // i = 0; i < m - 1; i++
		if (i->isZero()) {
			continue;
		}
		const F2term& LM = i->LM();

		for (j = i, ++j; j != G.end(); ++j) { // j = i + 1, j < m; j++
			if (!j->isZero() && j->LM().canBeDividedBy(LM)) {
				j->dividedBy(*i);
			}
		}
	}

	sortAndRemoveTrivialPoly(G, strategy);
}

/**
	󥰥֥ʡ(դ¸ߤ)
	@param G[in] ֥ʡ
	G[j] ˸ñ༰ LM(G[i])ǳʤ for i != j
*/
static void Reduce(F2poly::Set& G, PairStrategy& strategy)
{
RETRY:
	sortAndRemoveTrivialPoly(G, strategy);

	/*
		ब2İʾʤнλ
	*/
	if (G.size() < 2) {
		return;
	}

	bool isChanged = false;

	/*
		˳äƤߤ
	*/
	F2poly::Set::iterator i, j, prevEndG = G.end();
	--prevEndG;

	for (i = G.begin(); i != prevEndG; ++i) { // i = 0; i < m - 1; i++
		if (i->isZero()) {
			continue;
		}

		for (j = i, ++j; j != G.end(); ++j) { // j = i + 1, j < m; j++
			if (!j->isZero()) {
				isChanged |= j->reducedBy(*i);
			}
		}
	}

	/* QQQ:ȴ(äȱ黻̤ϸ餻) */
	if (isChanged) {
		goto RETRY;
	}
}

/**
	GB
	@param G [inout] in:¿༰ out:󥰥֥ʡ
*/
static void MakeGbaseBy(F2poly::Set& G)
{
	PairStrategy strategy;
	F2poly s;

	strategy.init(G);

	int count = 0;
	while (!IsGbase(G, s, strategy)) {
		if (debug > 1) std::cout << "add poly:" << s << std::endl;
		G.push_back(s);
		strategy.add(G.back());
#if 1
//		if ((count & 3) == 0) {
			Reduce(G, strategy);
//		}
#else
		if ((count & 7) == 0) {
			Simplify(G, strategy);
		} else {
			Reduce(G, strategy);
		}
#endif
		count++;
printf("num of G=%d, pair size=%d\n", (int)G.size(), (int)strategy.getNumOfSij());
//PutF2polySet(G, 'G');
		}
puts("loop end\nnow reducing");

	/*
		while()Reduce()򤷤Ƥ¤פä̤
		򤷤Ȥϥ롼פȴȤReduce()ƤȤϸ¤ʤ
	*/
	Reduce(G, strategy);
	assert(IsGbase(G, s, strategy));
}

} // end of namespace Basic

} // end of namespace Hotaru

#endif /* HTOARU_PAIR_SET_H_ */
