#ifndef MIE_COMMON_H_
#define MIE_COMMON_H_
/**
	@file mie_common.h
	@brief Ƽﶦե
	@author $Author: herumi $
	@version $Revision: 1.3 $
	@date $Date: 2005/02/16 13:39:46 $
*/

#define USE_ALLOCA

#if defined(__BORLANDC__) && !defined(WIN32)
#define WIN32
#endif

#if defined(__amd64__)
	#define MIE_CPU_AMD64
	#define MIE_LITTLE_ENDIAN
#elif defined(_M_IX86) || defined(__linux__) || defined(__CYGWIN__) || defined(__MINGW32__)
	#define MIE_CPU_I386
	#define MIE_LITTLE_ENDIAN
#elif defined(__MWERKS__) || defined(__APPLE__) /* Macintosh */
	#define MIE_CPU_PPC
	#define MIE_BIG_ENDIAN
#else
	#error "Define CPU type"
#endif

#if !defined(MIE_LITTLE_ENDIAN) && !defined(MIE_BIG_ENDIAN)
	#error "define endian type"
#endif

#if defined(_MSC_VER) && !defined(max)
	#define max(x,y) (((x) >= (y)) ? (x) : (y))
	#define min(x,y) (((x) <= (y)) ? (x) : (y))
#endif

#ifndef MIE_DEFINED_UINT32
	#define MIE_DEFINED_UINT32
	typedef unsigned int uint32;
	typedef signed int sint32;
	typedef unsigned short uint16;
	typedef signed short sint16;
	typedef unsigned char uint8;
	typedef signed char sint8;
#endif /* DEFINED_UINT32 */

#if defined(_MSC_VER) || defined(__BORLANDC__)
	typedef unsigned __int64 uint64;
	typedef __int64 sint64;
#elif defined(__MWERKS__)
	typedef unsigned long long uint64;
	typedef long long sint64;
#elif defined(__GNUC__) || defined(__HIGHC__) || defined(__CYGWIN__)
	typedef unsigned long long uint64;
	typedef long long sint64;
#elif defined(__amd64__)
	typedef unsigned long uint64;
	typedef long sint64;
#else
	#error "Define int64"
#endif

#ifndef LE2uint16
#ifdef _MSC_VER
#pragma warning(push)
#pragma warning(disable : 4035) /* ͤޤ */
#pragma warning(disable : 869) /* ̤ѿ */

__inline uint16 MIE_SWAP16BIT(uint16 x)
{
	_asm {
		movzx eax, word ptr x;
		bswap eax;
		shr eax, 16;
	}
}
__inline uint32 MIE_SWAP32BIT(uint32 x)
{
	_asm {
		mov eax, x;
		bswap eax;
	}
}

#pragma warning(pop)
#else
	#define MIE_SWAP16BIT(x) ( (((x)<<8)&0xFF00) | (((x)>>8)&0x00FF) )
	#define MIE_SWAP32BIT(x) ( ((x)<<24) | (((x)<<8)&0x00FF0000) | (((x)>>8)&0x0000FF00) | (((x)>>24)&0xFF) )
#endif

#ifdef MIE_LITTLE_ENDIAN
	#define LE2uint16(x) (x)
	#define LE2uint32(x) (x)
	#define BE2uint16(x) MIE_SWAP16BIT(x)
	#define BE2uint32(x) MIE_SWAP32BIT(x)
	#define MIE_PACK(x,y,z,w) ((((uint32)(x))<<24)|(((uint32)(y))<<16)|(((uint32)(z))<<8)|((uint32)(w)))
#else
	#define BE2uint16(x) (x)
	#define BE2uint32(x) (x)
	#define LE2uint16(x) MIE_SWAP16BIT(x)
	#define LE2uint32(x) MIE_SWAP32BIT(x)
	#define MIE_PACK(x,y,z,w) (((uint32)(x))|(((uint32)(y))<<8)|(((uint32)(z))<<16)|(((uint32)(w))<<24))
#endif

#endif /* LE2uint16 */

/* inline macro */
#if defined(__GNUC__) || defined(__MWERKS__)
	#define INLINE inline
	#define STATIC_INLINE static inline
#elif defined(_MSC_VER)
	#define INLINE __inline
	#define STATIC_INLINE static __inline
#else
	#define INLINE
	#define STATIC_INLINE static
#endif

#ifdef NDEBUG
	#define PRINTF(x)
#else
	#define PRINTF(x) printf x
#endif

#ifdef WIN32
#define SNPRINTF _snprintf
#else
#define SNPRINTF snprintf
#endif

#ifdef _MSC_VER
	#pragma warning(disable : 4514) /* inlineؿ */
	#pragma warning(disable : 4786) /* ̻ҤĹ */
#endif

/* misc */

/*
	clock ¬
*/
#ifdef __cplusplus
extern "C" {
#endif

void clkbegin(void);
void clkend(void);
void clkput(void);

#ifdef __cplusplus
}
#endif

#if defined(__cplusplus) && defined(_MSC_VER) && (_MSC_VER <= 1200)
	#define for if(0);else for
#endif

#if 1
	#define MALLOC(x) malloc(x)
	#define FREE(x) free(x)
#else
	#error ""
#endif

#ifdef USE_ALLOCA
	#if defined(WIN32)
		#define ALLOCA_(x) _alloca(x)
	#elif defined(__GNUC__)
		#define ALLOCA_(x) alloca(x)
	#else
		#error "define ALLOCA_"
	#endif
	#define ALLOCA(x) (void *)(((int)ALLOCA_((x) + 16) + 15) & ~15)
	#if defined(WIN32)
		#include <malloc.h>
	#endif
#endif

#define NUM_OF_ARRAY(x) (sizeof(x)/sizeof(x[0]))

#endif /* MIE_COMMON_H_ */
