/**
	ʰץ󥽡
	@brief
	@author $Author: dskw $
	@version $Revision: 1.6 $
	@date $Date: 2005/02/24 04:17:58 $
*/

#define USE_F4
#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include <fstream>
#include <unistd.h>
#include <sys/stat.h>

using namespace Hotaru;
using namespace std;


int main(int ac, char *av[]) {
	if(ac < 2) exit(0);
	int num = ::atoi(av[1]);
	
	static char fname[32];
	struct stat sb;
	F4::ReductionF4 R;
	
	changeInputFormat(ALPHABET);
	changeOutputFormat(ALPHABET);
	
	::sprintf(fname, "F%d", num);
	ofstream ofs(fname, ios::trunc|ios::out); ofs.close();
	
	F2poly::Set F;
	for (;;) {
		for(;;) {
			::sprintf(fname, "P%d", num);
			if(!::stat(fname, &sb)) break;
			::usleep(1000);
		}
		
		F2poly::Set G;
		::sprintf(fname, "G%d", num);
		ifstream inG(fname);
		string s;
		while(getline(inG, s)) G.push_back(F2poly(s.c_str()));
		inG.close();
		
		int n = G.size();
		F2poly const* *ip = new F2poly const*[n];
		F2poly::Set::iterator iG = G.begin();
		for(int i = 0; i < n; ++i) ip[i] = &*iG++;
		
		F4::PairList P;
		::sprintf(fname, "P%d", num);
		ifstream inP(fname);
		while(getline(inP, s)) {
			int p1 = -1, p2 = -1;
			::sscanf(s.c_str(), "%d, %d", &p1, &p2);
			if(p2 < 0) P.push_back(F4::Pair(*ip[p1], ~p2));
			else P.push_back(F4::Pair(*ip[p1], *ip[p2]));
		}
		inP.close();
		::unlink(fname);
		
		delete [] ip;
	
		if(P.size()) {
			F.clear();
			R(P, G, F);
		} else {
			F4::PolySet H;
			H.addSet(F);
			H.reduceBy(G);
			F.clear();
			H.getSet(F);
		}
		
		::sprintf(fname, "_F%d", num);
		ofstream outF(fname, ios::trunc|ios::out);
		F2poly::Set::iterator iF = F.begin();
		for(; iF != F.end(); ++iF) outF << *iF << endl;
		outF.close();
		::rename(fname, fname+1);
	}
	return 0;
}
