/**
	ʰץ󥽡
	@brief ֥ʡ׻ġ
	@author $Author: dskw $
	@version $Revision: 1.1 $
	@date $Date: 2005/02/04 20:44:20 $
*/

#define USE_PARAF4
#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include <time.h>

using namespace Hotaru;
using namespace std;

#ifndef USE_F4
	#define METHOD	Basic
//	#define METHOD	History
//	#define METHOD	PairSet
#else
	#ifndef	USE_PARAF4
		#define METHOD	F4
	#else
		#define METHOD	ParaF4
	#endif
#endif

int main(int ac, char *av[])
{
#ifdef USE_PARAF4
	if(ac < 3) exit(0);
	ParaF4::nFirst = ::atoi(av[1]);
	ParaF4::nLast  = ::atoi(av[2]);
	ParaF4::InitChildren();
#endif
	cout << "HOTARU ver. " << (VERSION >> 8) << "." << (VERSION & 0xFF) << endl;
	cout << "Copyright (C) 2004 herumi and dsk." << endl;
	cout << "METHOD:" << METHOD::getString() << endl;
	for (;;) {
		F2poly::Set G;

		cout << "input polynomials." << endl;
		cout << "type .(period) if you want to stop." << endl;

		changeInputFormat(ALPHABET);
		changeOutputFormat(ALPHABET);

#if 1
		bool isEnd = false;
		do {
			const size_t lineMax = 65536;
			string expr;
			/*
				1ԤʣԤˤʤäƤ褤1Ԥν,ȽǤ롥
				ϤνƬ.ιԤǤ롥
				ޤΤȤˤϲ⼰̵Ȥ()
			*/
			for (;;) {
				char line[lineMax];
				cin.getline(line, lineMax);

				if (*line == '.') {
					/* ХåեˤΤϺǽ */
					F2poly f(expr.c_str());
					if (!f.isZero()) {
						G.push_back(f);
					}
					isEnd = true;
					break;
				}
				expr += line;
				if (find(expr.rbegin(), expr.rend(), ',') != expr.rend()) {
					F2poly f(expr.c_str());
					if (!f.isZero()) {
						G.push_back(f);
						break;
					}
				}
			}
		} while (!isEnd);
#else
		for (;;) {
			char line[65536];
			cin.getline(line, sizeof(line));

			if (*line == '.') {
				cout << "input end." << endl;
				break;
			} else {
				F2poly f(line);
				if (!f.isZero()) {
					G.push_back(f);
				}
			}
		}
#endif
		if (G.size()) {
			cout << "input polynomials are:" << endl;
			PutF2polySet(G, 'G');
			cout << "computing Groebner basis." << endl;
			clock_t begin = clock();
			METHOD::MakeGbaseBy(G);
			clock_t end = clock();
			double second = (end - begin) / double(CLOCKS_PER_SEC);
#if 1
			for (F2poly::Set::const_iterator itr = G.begin(); itr != G.end(); ++itr) {
				cout << *itr << ',' << endl;
			}
			cout << "num of G:" << G.size() << endl;
#else
			PutF2polySet(G, 'G');
			cout << "result:" << endl;
#endif
			cout << "time:" << second << "sec" << endl;

		} else {
			break;
		}
	}
	return 0;
}
