/**
	F2polyƥ
*/

#ifdef _MSC_VER
	#pragma warning(disable : 4530) // 㳰Ȥʤ
#endif

// for Leak Check
#include "cudebug.h"

#include "TestCase.h"
#include "TestSuite.h"
#include "TestCaller.h"
#include "TestRunner.h"

#include <sstream>
#include <list>
#include <algorithm>
#include <functional>

#define MAIN_INSTANCE_HERE
#include "hotaru.h"
#include "mylist.h"

using namespace Hotaru;

#define PUT(x) std::cout << #x "=" << x << std::endl

USING_NAMESPACE_CPPUNIT

/**
	xoffset+1, ..., offset+32ޤǤΥӥåȤvalˤ
*/
void setBy(F2term& x, uint32 val, int offset)
{
	for (int i = 0; i < 32; i++) {
		int idx = i + offset + 1;
		if (idx >= MAX_NUM_OF_VARIABLE) continue;
		if (val & (1<<i)) {
			x.setVar(idx);
		} else {
			x.clearVar(idx);
		}
	}
}

/**
	[p[3]:p[2]:p[1]:p[0]]F2term
*/
F2term makeBy(uint32 *p)
{
	F2term ret;
	for (int i = 0; i < 4; i++) {
		setBy(ret, p[0], i * 32);
	}
	return ret;
}

/**
	[a3:a2:a1:a0]F2term
*/
F2term makeBy(uint32 a0, uint32 a1 = 0, uint32 a2 = 0, uint32 a3 = 0)
{
	uint32 p[] = {a0, a1, a2, a3};
	return makeBy(p);
}

class F2termTest : public TestCase {
	
	TEST_CASE_COMMON(F2termTest)

public:
	// ƥȤν
	virtual void setUp()
	{
	}

	// ƥȤθդ
	virtual void tearDown()
	{
	}

	// åƥ
	void init()
	{
		{
			F2term f;

			// 󥹥ȥ饯1ˤʤ
			TEST_ASSERT(f.isOne());

			// 1Ǥ
			for (size_t i = 0; i < MAX_NUM_OF_VARIABLE; i++) {
				if (f.hasVar(i)) {
					TEST_ASSERT(0);
				}
			}

			// ԡ󥹥ȥ饯
			f.setVar(1);
			F2term g(f);
			TEST_ASSERT(f == g);

			f.setVar(3);
			// 黻
			g = f;
			TEST_ASSERT(f == g);
		}

		{
			// ʸˤ(1)
			F2term f("1");
			TEST_ASSERT(f.isOne());
		}
		{
			// ʸˤ(Τñ༰)
			F2term f1("(1)");
			F2term g;
			g.setVar(1);
			TEST_ASSERT(f1 == g);
			F2term f2("(1, 3)");
			g.setVar(3);
			TEST_ASSERT(f2 == g);
			F2term f3("(1, 3, 5)");
			g.setVar(5);
			TEST_ASSERT(f3 == g);
		}
	}

	// 
	void accessor()
	{
		F2term f;

		f.setOne(); // 1Ǥ
		TEST_ASSERT(f.isOne());
		for (size_t i = 0; i < MAX_NUM_OF_VARIABLE; i++) {
			if (f.hasVar(i)) {
				TEST_ASSERT(0);
			}
		}

		// x1
		f.setVar(1);
		TEST_ASSERT(f.hasVar(1));

		// 1
		TEST_ASSERT(f.getDegree() == 1);

		// x1򥯥ꥢ
		f.clearVar(1);
		TEST_ASSERT(f.isOne());

		// x1x128
		for (size_t i = 0; i < MAX_NUM_OF_VARIABLE; i++) {
			f.setVar(i);
		}
		TEST_ASSERT(f.getDegree() == MAX_NUM_OF_VARIABLE);

		// ʸˤ
		{
			std::istringstream istr("(1,2,3,4,5  , 8, 12)");
			istr >> f;
			F2term g;
			const int tbl[] = {1, 2, 3, 4, 5, 8, 12};
			for (size_t i = 0; i < NUM_OF_ARRAY(tbl); i++) {
				g.setVar(tbl[i]);
			}
			TEST_ASSERT(f == g);
		}
	}

	// ϥƥ
	void output()
	{
		// 1
		{
			F2term f;
			std::ostringstream ostr;
			f.setOne();
			ostr << f;
			TEST_ASSERT(ostr.str() == "1");
		}
		// 
		{
			F2term f;
			std::ostringstream ostr;
			f.setVar(3);
			ostr << f;
			switch (OutputFormatType) {
			case MAPLE:
				TEST_ASSERT(ostr.str() == "x[3]");
				break;
			case SIMPLE:
				TEST_ASSERT(ostr.str() == "(3)");
				break;
			case ALPHABET:
				TEST_ASSERT(ostr.str() == "c");
				break;
			default:
				std::cerr << "not support" << std::endl;
			}
		}

		// ʣ
		{
			F2term f("(1,3,5)");
			std::ostringstream ostr;
			ostr << f;

			switch (OutputFormatType) {
			case MAPLE:
				TEST_ASSERT(ostr.str() == "x[1] * x[3] * x[5]");
				break;
			case SIMPLE:
				TEST_ASSERT(ostr.str() == "(1, 3, 5)");
				break;
			case ALPHABET:
				TEST_ASSERT(ostr.str() == "ace");
				break;
			default:
				std::cerr << "not support" << std::endl;
			}
		}
	}

	// ӥƥ
	void compare()
	{
		{
			// Ʊ
			F2term f, g;

			TEST_ASSERT(f == g);
			g.setOne();
			f = g;
			TEST_ASSERT(f == g);

			TEST_ASSERT(f == g);
			f.setVar(12);
			g.setVar(12);
			TEST_ASSERT(f == g);

			f.setVar(3);
			g.setVar(3);
			TEST_ASSERT(f == g);

			if (Hotaru::MAX_NUM_OF_VARIABLE >= 100) {
				f.setVar(100);
				g.setVar(101);
				TEST_ASSERT(!(f == g));
			}
		}

		{
			F2term one;
			// x_i > x_j for i < j, : x_n < x_(n-1) < ... < x_2 < x_1
			for (int i = 0; i < MAX_NUM_OF_VARIABLE - 1; i++) {
				F2term f;
				f.setVar(i);
				TEST_ASSERT(f > one);
				for (int j = i + 1; j < MAX_NUM_OF_VARIABLE; j++) {
					F2term g;
					g.setVar(j);
					TEST_ASSERT(f > g);
				}
			}
		}
		{
			// x2 x3 > x1
			F2term f("(1)");
			F2term g("(2, 3)");
			TEST_ASSERT(f < g);
		}
		// x2 x3 > x1 x4
		{
			F2term f("(2, 3)");
			F2term g("(1, 4)");
			TEST_ASSERT(f > g);
		}
		// x1 x2 x4 < x1 x2 x3
		{
			F2term f("(1, 2, 4)");
			F2term g("(1, 2, 3)");
			TEST_ASSERT(f < g);
		}
	}

	// ݤƥ
	void mul()
	{
		{
			F2term f("(1, 5)");
			F2term g, h;
			// 1ݤƤѤʤ
			g.setOne();
			h = f;
			f *= g;
			TEST_ASSERT(f == h);

		}
		{
			// (3) * (10) = (3, 10)
			F2term f("(3, 10)");
			F2term g("(3)");
			F2term h("(10)");
			g *= h;
			TEST_ASSERT(f == g);
		}
		{
			// 褷ƤѤʤ
			F2term f, g;
			for (int i = 0; i < 10; i++) {
				f.setVar(i);
			}
			g = f;
			f *= f;
			TEST_ASSERT(f == g);
		}

		{
			// LCM(ȤmulƱ)
			F2term f, g, h;
			for (int i = 1; i < 10; i += 2) {
				f.setVar(i);
			}
			for (int i = 2; i < 10; i += 2) {
				g.setVar(i);
			}
			for (int i = 1; i < 10; i++) {
				h.setVar(i);
			}
			F2term lcm = F2term::getLCM(f, g);
			TEST_ASSERT(lcm == h);
		}
	}

	// 껻ƥ
	void dev()
	{
		{
			F2term one;
			F2term f("(1, 5)");
			F2term g("(5)");
			F2term h("(3)");

			// fgǳ
			TEST_ASSERT(f.canBeDividedBy(g));
			// 1ǳ
			TEST_ASSERT(f.canBeDividedBy(one));
			// fhǳʤ
			TEST_ASSERT(!f.canBeDividedBy(h));

			{
				// f1ǳäƤѤʤ
				F2term t = f;
				t /= one;
				TEST_ASSERT(t == f);
			}
			// fgǳ(1)ˤʤ
			F2term x; x.setVar(1);
			f /= g;
			TEST_ASSERT(f == x);

			// ffǳ1ˤʤ
			for (int i = 1; i < MAX_NUM_OF_VARIABLE; i += 7) {
				f.setVar(i);
			}
			f /= f;
			TEST_ASSERT(f.isOne());
		}
	}

	static Test* suite()
	{
		TestSuite* suite = new TestSuite("F2termTest");
		// TEST_CASE ޥѤƥƥȥ֥Ȥ
		suite->addTest(new TEST_CASE(F2termTest, init));
		suite->addTest(new TEST_CASE(F2termTest, accessor));
		suite->addTest(new TEST_CASE(F2termTest, output));
		suite->addTest(new TEST_CASE(F2termTest, compare));
		suite->addTest(new TEST_CASE(F2termTest, mul));
		suite->addTest(new TEST_CASE(F2termTest, dev));
		return suite;
	}
};

class F2polyTest : public TestCase {
	
	TEST_CASE_COMMON(F2polyTest)

public:
	// ƥȤν
	virtual void setUp()
	{
	}

	// ƥȤθդ
	virtual void tearDown()
	{
	}

	// 
	void init()
	{
		{
			// 󥹥ȥ饯0ꥢ
			F2poly f;
			TEST_ASSERT(f.isZero());
		}

		{
			F2poly f("(1, 2, 3)");
			F2term g("(1, 2, 3)");
			f += g;
			TEST_ASSERT(f.isZero());
		}

		{
			// Τ⤢(fϼ¤0)
			F2poly f("(3, 4) + (1, 2, 5) + (5, 2, 1) + (4, 3)");
			TEST_ASSERT(f.isZero());

			F2poly g("(2, 4, 1) + (4, 1, 3, 4)");
			
			std::ostringstream ostr;
			ostr << g;

			switch (OutputFormatType) {
			case MAPLE:
				TEST_ASSERT(ostr.str() == "x[1] * x[2] * x[4] + x[1] * x[3] * x[4]");
				break;
			case SIMPLE:
				TEST_ASSERT(ostr.str() == "(1, 2, 4) + (1, 3, 4)");
				break;
			case ALPHABET:
				TEST_ASSERT(ostr.str() == "abd + acd");
				break;
			default:
				std::cerr << "not support" << std::endl;
			}
		}

		{
			F2poly f("(1, 2, 3) + (9, 10, 11)");
			F2poly g;
			F2term s("(1,2,3)");
			F2term t("(9,10, 11)");
			g = s;
			g += t;
			f -= g;
			TEST_ASSERT(f.isZero());
		}
	}

	// ûӥƥ
	void addCompare()
	{
		{
			F2poly f("(12)");
			F2term g("(12)");
			TEST_ASSERT(!f.isZero());
			f += g; // f = 0
			TEST_ASSERT(f.isZero());
		}

		{
			F2poly f, h, t;
			for (int i = 0; i < 10; i++) {
				F2term g;
				for (int j = 0; j < (rand() % 10) + 1; j++) {
					g.setVar(rand() % MAX_NUM_OF_VARIABLE);
				}
				f += g;
				h += g;
			}
			t = f;
			f += h; // Ʊͤ­0
			TEST_ASSERT(f.isZero());
			f = t;
			f += f; // ƱѿƱΤǤOK
			TEST_ASSERT(f.isZero());
		}
	}

	// ݤƥ
	void mul()
	{
		{
			// (1, 3) * (1, 3) = (1, 3)
			F2poly f;
			F2term g("(1, 3)");
			f += g;
			f *= f;
			f += g;
			TEST_ASSERT(f.isZero());
		}
		{
			// f = (1, 3) + (2, 4)
			// g = (2, 3) + (1, 4)
			// f * g = (1, 2, 3) + (1, 3, 4) + (2, 3, 4) + (1, 2, 4)
			F2poly f("(1, 3) + (2, 4)");
			F2poly g("(2, 3) + (1, 4)");
			F2poly h("(1, 2, 3) + (1, 3, 4) + (2, 3, 4) + (1, 2, 4)");
			f *= g;
			f -= h;

			TEST_ASSERT(f.isZero());
		}
		{	// ݤ0ˤʤ
			F2poly f("(1) + (2)");
			F2poly g("(1, 2)");
			f *= g;
			TEST_ASSERT(f.isZero());
		}
	}

	// leading term
	void LT()
	{
		F2poly f;
		F2term g;
		g.setVar(1);
		f += g;
		g.setVar(3);
		f += g;
		g.setVar(12);
		f += g;
		g.setVar(15);
		f += g;
		g.clearVar(12);
		f += g;
		// f = (1, 3, 12, 15) + (1, 3, 12) + (1, 3, 15) + (1, 3) + (1)
		g.setVar(12);
		TEST_ASSERT(f.LT() == g);
	}

	// Spoly
	void Spoly()
	{
		F2poly f("(1, 2, 3) + (4, 5) + (1, 2, 4)");
		F2poly g("(2, 4) + (1, 2)");
		F2poly s("(1, 2, 4) + (2, 3, 4) + (4, 5)");
		F2poly ret = F2poly::GetSpoly(f, g);
		ret -= s;
		TEST_ASSERT(ret.isZero());
	}


	F2poly makePoly(int termNum)
	{
		F2poly f;
		for (int i = 0; i < termNum; i++) {
			uint32 p[4];
			for (size_t i = 0; i < NUM_OF_ARRAY(p); i++) {
				p[i] = rand();
			}
			f += makeBy(p);
		}
		return f;
	}

	// ñ༰ˤ껻
	void dividedBy()
	{
		F2poly f("(1,2)+(2,3)+(3,4)+(4,5)+(5,6)");
		F2poly g("(1,2,3)+(2,3,4)+(3,4,5)+(4,5,6)");
		F2poly r("(2, 3, 4) + (3, 5, 6) + (4, 5, 6) + (2, 3) + (3, 4)");
		g.dividedAndGetQuotientBy(f);
		TEST_ASSERT(g == r);
	}

	// ¿༰ˤ껻
	void dividedBySet()
	{
		F2poly f = makePoly(10);
		F2poly::Set F;
		const int m = 6;

		for (int i = 0; i < m; i++) {
			F.push_back(makePoly((rand() % 5) + 3));
		}
		F2poly r = f;
		F2poly::Set G;
		G = r.dividedAndGetQuotientBy(F);

		const F2poly::pvecSet vF = F2poly::convertToVector(F);
		const F2poly::pvecSet vG = F2poly::convertToVector(G);

#if 0
		std::cout << f << " = ";

		for (int i = 0 ;i < m; i++) {
			std::cout << "(" << *vG[i] << ")(" << *vF[i] << ")";
			if (i < m - 1) {
				std::cout << " + ";
			}
		}
		std::cout << " + (" << r << ")" << std::endl;
#endif

		// 
		for (int i = 0; i < m; i++) {
			F2poly t;
			t = *vG[i];
			t *= *vF[i];
			r += t;
		}
		f -= r;
		TEST_ASSERT(f.isZero());
	}

	void sketch()
	{
#if 0
		puts("");
		F2poly f = "(1, 2, 3, 4, 7) + (1,2,5) + (2,3,7) + (3,4) + (1,7) + 1";
		const char tbl[][64] = { "(2,3,7) + (1,2)", "(3,5) + 1", "(4)" };
		const size_t m = NUM_OF_ARRAY(tbl);

		F2poly::Set F, G;
		F2poly::pvecSet vF, vG;

		for (size_t i = 0; i < m; i++) {
			F.push_back(tbl[i]);
		}

		std::cout << f << " = ";
		G = f.dividedAndGetQuotientBy(F);

		vF = F2poly::convertToVector(F);
		vG = F2poly::convertToVector(G);

		for (size_t i = 0 ;i < m; i++) {
			std::cout << "(" << *vG[i] << ")(" << *vF[i] << ")";
			if (i < m - 1) {
				std::cout << " + ";
			}
		}
		std::cout << " + (" << f << ")" << std::endl;

		// display F
		vF = F2poly::convertToVector(F);
		std::cout << "F is {" << std::endl;
		for (size_t i = 0; i < F.size(); i++) {
			std::cout << "    F[" << i << "]=" << *vF[i] << "," << std::endl;
		}
		puts("}");
		std::cout << "F " << (Basic::IsGbase(F) ? "is" : "isn't") << " Groebner basis" << std::endl;

		std::cout << "make Groebner basis" << std::endl;

		Basic::MakeGbaseBy(F);
		vF = F2poly::convertToVector(F);

		// display F
		vF = F2poly::convertToVector(F);
		std::cout << "F is {" << std::endl;
		for (size_t i = 0; i < F.size(); i++) {
			std::cout << "    F[" << i << "]=" << *vF[i] << "," << std::endl;
		}
		puts("}");
		std::cout << "F " << (Basic::IsGbase(F) ? "is" : "isn't") << " Groebner basis" << std::endl;
#endif
	}

	static Test* suite()
	{
		TestSuite* suite = new TestSuite("F2polyTest");
		// TEST_CASE ޥѤƥƥȥ֥Ȥ
		suite->addTest(new TEST_CASE(F2polyTest, init));
		suite->addTest(new TEST_CASE(F2polyTest, addCompare));
		suite->addTest(new TEST_CASE(F2polyTest, LT));
		suite->addTest(new TEST_CASE(F2polyTest, mul));
		suite->addTest(new TEST_CASE(F2polyTest, Spoly));
		suite->addTest(new TEST_CASE(F2polyTest, dividedBy));
		suite->addTest(new TEST_CASE(F2polyTest, dividedBySet));
		suite->addTest(new TEST_CASE(F2polyTest, sketch));
		return suite;
	}
};

int main(int argc, char* argv[])
{
#if defined(ENABLE_LEAK_CHECKER) && !defined(_MSC_VER)
	LeakChecker checker;
#endif

	int result = 0;

	// TestRunner ˥ƥȤɲäƼ¹Ԥ롣
	TestRunner runner;
	runner.addTest("F2termTest", F2termTest::suite());
	runner.addTest("F2termTest", F2polyTest::suite());

	result += runner.run(argc, argv);
	return result;
}

// ʲεҤϥǥХåѤʤΤ̵뤷Ƥ
#ifdef USE_DEBUGTOOLS
#  include <debug/debugtools.cpp>
#endif

#if defined(ENABLE_LEAK_CHECKER) && defined(_MSC_VER)
#  pragma warning(disable:4073)
#  pragma init_seg(lib)
LeakChecker g_leakChecker;
#endif
