/**
	cyclic(n)Ϥġ

	@author $Author: herumi $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2004/12/08 14:32:37 $
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../app/option_base.h"

class MakeCyclicOption : public OptionBase {
private:
	int n_; /* Ŀ */
	int type_; /* ɽ */
	void usage()
	{
		fprintf(stderr, "make_cyclic -n num [-type type]\n");
		fprintf(stderr, "    -type type : mul\n");
	}
public:
	enum {
		NONE,
		WITH_MUL, /* '*' */
	};

	MakeCyclicOption()
		: n_(-1)
		, type_(0)
	{
	}
	/**
		ץ
	*/
	bool analyze(int argc, const char *const argv[])
	{
		set(argc, argv);
		
		while (hasOption()) {
			if (isMatch("-n", 1)) {
				n_ = getInteger();
			} else
			if (isMatch("-type", 1)) {
				const char *s = getString();
				if (strcmp(s, "mul") == 0) {
					type_ = WITH_MUL;
				}
			} else
			{
				usage();
				return false;
			}
			next();
		}

		if (n_ <= 0) {
			fprintf(stderr, "illegal number=%d\n", n_);
			usage();
			return false;
		}
		return true;
	}
	/**
		å
	*/
	int getNumber() const { return n_; }
	int getType() const { return type_; }
};

class MakeCyclic {
private:
	MakeCyclicOption opt_;

	/**
		x[start] * ... * x[(start + len - 1) % bound]ɽ
	*/
	void put(int start, int len, int bound)
	{
		bool withMul = opt_.getType() == MakeCyclicOption::WITH_MUL;
		for (int i = 0; i < len; i++) {
			putchar('a' + ((start + i) % bound));
			if (withMul && i < len - 1) putchar('*');
		}
	}
public:
	MakeCyclic(const MakeCyclicOption& opt)
		: opt_(opt)
	{
	}

	bool run()
	{
		int n = opt_.getNumber();

		/* Ƭ */
		put(0, n, n);
		printf(" + 1,\n");
		for (int len = n - 1; len > 0; len--) {
			for (int i = 0; i < n; i++) {
				put(i, len, n);
				if (i < n - 1) printf(" + ");
			}
			printf(",\n");
		}
		return true;
	}
};

int main(int argc, char *argv[])
{
	MakeCyclicOption opt;
	if (opt.analyze(argc, argv)) {
		MakeCyclic cyclic(opt);
		cyclic.run();
		return 0;
	}
	return 1;
}
